#include	<stdlib.h>
#include	<qtimer.h>
#include	<qobject.h>
#include	<qlist.h>
#include	<qstring.h>
#include	<CxClient.h>
#include	<iostream.h>
#include <netdb.h>
#include	"cxconnection.h"

/**
 ** CxConnection::CxConnection(): 
 **/		
		CxConnection::CxConnection( const QString& host, const QString& user, const QString& pass )
		:QObject( 0, "CxConnection" ) {

	g_userName = new QString( user );
	g_password = new QString( pass );
	g_serverName = new QString( host );
	g_isOnline = false;
	g_isConfigured = false;

	l_floorIndex = l_roomsIndex = l_usersIndex = l_allUsersIndex = 0L;
}


/**
 ** CxConnection::CxConnection(): 
 **/		
		CxConnection::~CxConnection() {

	if(g_isOnline) citDisconnect();

	cout << "Deleting cxHndl " <<g_cxHndl << endl;
	if(g_cxHndl) CxClDelete(g_cxHndl);

	delete g_userName;
	delete g_password;
	delete g_serverName;
}

/**
 ** CxConnection::citConnect(): 
 **/
void		CxConnection::citConnect() {
USERINFO	*info;
int		myerr;
void		*data;

	if(g_isOnline || !g_isConfigured) return;
	if(g_serverName->isEmpty()) return;
	if(g_userName->isEmpty()) return;
	if(g_password->isEmpty()) return;

	cout << "serverName: " << g_serverName->ascii() << endl;
	cout << "userName: " << g_userName->ascii() << endl;
	g_cxHndl = CxClConnection( g_serverName->ascii(), 504, g_userName->ascii(), g_password->ascii() );
	cout << "Received cxHndl " << g_cxHndl << endl;
	if(!g_cxHndl) return;

	/**
	 ** Connect to the Citadel/UX host.
	 **/
	cerr << "Connecting " << g_cxHndl << endl;
	myerr = CxClConnect( g_cxHndl );
	cerr << myerr << endl;
	if(!myerr) {
		cerr << "Connected!  Coming online..." << endl;
		emit comingOnline();

		if(  	( g_userName && (!g_userName->isNull())) &&
			( g_password && (!g_password->isNull())) ) {

			cerr << "Authenticating " << g_cxHndl << "..." << endl;
			if(!(info = CxUsAuth( g_cxHndl, NULL, NULL ))) {  //g_userName->ascii(), g_password->ascii()))) {
				cerr << "Failed!" << endl;
				citDisconnect();

				cerr << "Error: Invalid username and/or password!" << endl;
				emit error(QString("Invalid username and/or password!"));
				emit amOffline();

			} else {

				/* cout << "ALC malloc(i_userInfo)" << endl;
				i_userInfo = (USERINFO *) malloc(sizeof(USERINFO));
				cout << "memcpy()" << endl;
				memcpy( &i_userInfo, &info, sizeof(USERINFO)); */
				cout << "FRE free()" << endl;
				free(info);

				cout << "g_isOnline" << endl;
				g_isOnline = true;

				cout << "new refreshTimer() " << endl;
				QTimer *refreshTimer = new QTimer(this);
				cout << "changeInterval() timer" << endl;
				refreshTimer->changeInterval( 2500 );
				cout << "connect() timer" << endl;
				connect(refreshTimer, SIGNAL(timeout()), this, SLOT(checkExpressMsg()));

				cerr << "ONLINE" << endl;
				emit amOnline();

			}
		}

	} else {
		cerr << "Failed!" << endl;
		cerr << "Error: No Connection!" << endl;
		emit error(QString("Unable to connect to Citadel/UX server!\n")+QString(strerror(abs(myerr))));
	}
}

/**
 ** CxConnection::citDisconnect(): 
 **/
void		CxConnection::citDisconnect() {

	if(!g_isOnline) return;

	CxClDisconnect( g_cxHndl );
	CxClDelete( g_cxHndl );
	g_cxHndl = 0;
	g_isOnline = false;

	emit goingOffline();
	emit amOffline();
}

/**
 ** CxConnection::sync(): Synchronize my cached indices with the indices on the server.
 **/
void		CxConnection::sync() {

	cerr << "updatingStart()" << endl;
	emit updatingStart();

	cerr << "syncSlave()" << endl;
	QTimer::singleShot( 500, this, SLOT(syncSlave()));
}

/**
 ** CxConnection::syncSlave(): This is the REAL synchronization handler.
 **/
void		CxConnection::syncSlave() {

	cerr << "syncSlave() ENTERED" << endl;
	cerr << "Synchronizing..." << endl;

	cerr << "syncFloors()" << endl;
	emit syncFloors();
	cerr << "syncRooms()" << endl;
	emit syncRooms();
	cerr << "syncUsers()" << endl;
	emit syncUsers();
	cerr << "updatingFinish()" << endl;
	QTimer::singleShot( 500, this, SIGNAL(updatingFinish()));
	cerr << "Done!" << endl;
}

/**
 ** CxConnection::syncFloors(): Synchronize floors index.
 **/
void		CxConnection::syncFloors() {

	cout << "CxConnection::syncFloors()" << endl;
	cerr << "Synchronizing floors index..." << endl;
	if(l_floorIndex) l_floorIndex = CxLlFlush( l_floorIndex );
	l_floorIndex = CxFlList( g_cxHndl );
}

/**
 ** CxConnection::syncRooms(): Synchronize rooms index.
 **/
void		CxConnection::syncRooms() {

	cout << "CxConnection::syncRooms()" << endl;
	cerr << "Synchronizing rooms index..." << endl;
	if(l_roomsIndex) l_roomsIndex = CxLlFlush( l_roomsIndex );
	l_roomsIndex = CxRmList( g_cxHndl );
}

/**
 ** CxConnection::syncUsers(): Synchronize users index.
 **/
void		CxConnection::syncUsers() {

	cout << "CxConnection::syncUsers()" << endl;
	cerr << "Synchronizing users index..." << endl;
	if(l_usersIndex) l_usersIndex = CxLlFlush( l_usersIndex );
	l_usersIndex = CxUsOnline(  g_cxHndl, 0 );

	if(!l_allUsersIndex) {
		cerr << "Synchronizing allusers index..." << endl;
		l_allUsersIndex = CxUsList( g_cxHndl );
	}
}

/**
 ** CxConnection::getOnlineUsers(): Return a QList vector of online users.
 **/
QList<QString>	CxConnection::getOnlineUsers() {
CXLIST		x;
QList<QString>	toret;

	cout << "CxConnection::getOnlineUsers()" << endl;
	if(!l_usersIndex) return(toret);

	x = l_usersIndex;
	while( x ) {
		QString *foo = new QString( x->data );
		toret.append( foo );
		x = x->next;
	}

	return( toret );
}

/**
 ** CxConnection::getAllUsers(): Return a QList vector of all system users.
 **/
QList<QString>	CxConnection::getAllUsers() {
CXLIST		x;
QList<QString>	toret;

	cout << "CxConnection::getAllUsers()" << endl;
	if(!l_allUsersIndex) return(toret);

	x = l_allUsersIndex;
	while( x ) {
		QString *foo = new QString( x->data );
		toret.append( foo );
		x = x->next;
	}

	return( toret );
}

/**
 ** CxConnection::sendExpressMsg(): Send an express message to a remote user.
 **/
void		CxConnection::sendExpressMsg( const QString& user, const QString& message ) {

	cout << "CxConnection::sendExpressMsg()" << endl;
	if( CxMiExpSend( g_cxHndl, user.ascii(), message.ascii() ) ) {
		emit error(QString("Unable to send Express Message to ")+user);
	}
}

/**
 ** CxConnection::recvExpressMsg(): Receive the pending express message.
 **/
void		CxConnection::recvExpressMsg() {

	cout << "CxConnection::recvExpressMsg()" << endl;
	EXPRMESG *s = CxMiExpRecv(g_cxHndl);
 
	if(!s) return;
 
	emit handleExpressMsg( QString(s->sender), QString(s->message) );

/* 
	CxWndChat *win = &chatWin(QString(g_Ser[3]));
	if(win) {
		win->recvMesg(g_Ser[5]);
		win->show();
	}
 */

	free(s->message);
	free(s);
}

/**
 ** CxConnection::checkExpressMsg(): Check for express messages.
 **/
void		CxConnection::checkExpressMsg() {

	cout << "CxConnection::checkExpressMsg()" << endl;
	if(CxMiExpCheck( g_cxHndl )) {
		emit recvExpressMsg();
	}
}

/**
 ** CxConnection::floorCache(): Return a reference of the floor cache.
 **/
CXLIST		*CxConnection::floorCache() {

	cout << "CxConnection::floorCache()" << endl;
	return( &l_floorIndex );
}
