#ifndef		__CXCONNECTION_H__
#define		__CXCONNECTION_H__
#include	<qobject.h>
#include	<qlist.h>
#include	<qstring.h>
#include	<CxClient.h>

class		CxConnection: public QObject {
Q_OBJECT

public:

		CxConnection( const QString& = QString::null, const QString& = QString::null, const QString& = QString::null );
		~CxConnection();

inline	bool		isOnline() { return(g_isOnline); };

	QList<QString>	getOnlineUsers();
	QList<QString>	getAllUsers();

CXLIST*			floorCache();

signals:
	void		error( const QString& );
	void		comingOnline();
	void		amOnline();
	void		updatingStart();
	void		updatingFinish();
	void		goingOffline();
	void		amOffline();
	void		handleExpressMsg( const QString&, const QString& );
	void		expMesgFailed();

public slots:
	void		citConnect();
	void		citDisconnect();
	void		sync();
inline	void		setHostName( const QString& s ) { g_serverName = new QString( s ); g_isConfigured = true; };
inline	void		setUserName( const QString& s ) { g_userName = new QString( s );  g_isConfigured = true;};
inline	void		setPassword( const QString& s ) { g_password = new QString( s );  g_isConfigured = true;};
inline	QString		getHostName() { return( g_serverName->copy() ); };
inline	QString		getUserName() { return( g_userName->copy() ); };
	void		sendExpressMsg( const QString&, const QString& );
	void		checkExpressMsg();
	void		recvExpressMsg();

private slots:
	void		syncSlave();
	void		syncFloors();
	void		syncRooms();
	void		syncUsers();

private:
	QString		*g_userName,
			*g_password,
			*g_serverName;
	bool		g_isOnline,
			g_isConfigured;
	USERINFO	*i_userInfo;
	CXLIST		l_floorIndex,
			l_roomsIndex,
			l_usersIndex,
			l_allUsersIndex;
	int		g_cxHndl;

};

#endif
