/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: cxdaemon.o
 ** Date: 2001-03-08
 ** Last Revision: 2001-03-08
 ** Description: CxDaemon interface.
 ** CVS: $Id: cxdaemon.cpp,v 1.4 2001/05/16 22:40:53 brian Exp $
 **/
#include	<unistd.h>
#include	<iostream.h>
#include	<qtimer.h>
#include	<qdatetime.h>
#include	<qstring.h>
#include	<qtooltip.h>
#include	<qdrawutil.h>
#include	<qbitmap.h>
#include	<kapp.h>
#include	<kpopupmenu.h>
#include	<kcmdlineargs.h>
#include	<kpixmapeffect.h>
#include	<kdebug.h>
#include	<kiconeffect.h>
#include	<klocale.h>
#include	<kglobal.h>
#include	<kconfig.h>
#include	<ksimpleconfig.h>
#include	<kstyle.h>
#include	<kiconloader.h>
#include	<kprocess.h>
#include	<kmessagebox.h>
#include	<knotifyclient.h>
#include	<CxClient.h>
#include	"cxdaemon.h"
#include	"wndabout.h"
#include	"wndbuddylist.h"
#include	"wndprefs.h"
#include	"cxconnection.h"
#include	"cxdaemontray.h"
#include	"koevent.h"

/**
 ** CxDaemonMgr::CxDaemonMgr(): Constructor.
 **/
		CxDaemonMgr::CxDaemonMgr( const QString& fun, QWidget *parent, const char *name )
		:QObject( parent, name )
		,DCOPObject( this ) {
QTimer		*alarmTimer;

	if(fun.isNull()) ;

	docker = new CxDaemonTray( this, "CxDaemonTray" );
	docker->show();
 
//	calendar = new CalendarLocal;
//	calendar->showDialogs(FALSE);
 
//	mAlarmDialog = new AlarmDialog;
//	connect(mAlarmDialog,SIGNAL(suspendSignal(int)),SLOT(suspend(int)));
 
//	calendar->load(fn);
 
	// set up the alarm timer
	alarmTimer = new QTimer(this);
	mSuspendTimer = new QTimer(this);
 
//	connect(alarmTimer, SIGNAL(timeout()), calendar, SLOT(checkAlarms()));
//	connect(calendar, SIGNAL(alarmSignal(QList<KOEvent> &)), this, SLOT(showAlarms(QList<KOEvent> &)));
 
	// timeout every minute.
//	alarmTimer->start(1000*60);
}

/**
 ** CxDaemonMgr::~CxDaemonMgr(): DESTRUCTOR.
 **/
		CxDaemonMgr::~CxDaemonMgr() {

//	delete calendar;
	delete docker;
}

/**
 ** CxDaemonMgr::process(): Do stuff.
 **/
bool		CxDaemonMgr::process(const QCString &cmd, const QByteArray &data, QCString &replyType, QByteArray &replyData) {

	if(data || replyType || replyData ) ;

	/**
	 ** "sync()": Synchronize cached lists.
	 **/
	if(cmd == "sync()") {
		emit docker->syncLists();
		return true;

	/**
	 ** "buddyList()": Raise the BuddyList window.
	 **/
	} else if(cmd == "buddyList()") {
		emit docker->raiseBuddyDlg();
		return true;

	/**
	 ** "floorList()": Return a list of floors.
	 **/
	} else if(cmd == "floorList()") {

//		QDataStream reply(replyData, IO_WriteOnly);
//		reply << docker->getFloorCache();
//		replyType = "CXLIST *";
		return true;
	
	/**
	 ** UNKNOWN MESSAGE.
	 **/
	} else {
		cout << "RECEIVED UNKNOWN MESSAGE: " << cmd << endl;
		return false;
	}

}

/**
 ** CxDaemonMgr::showAlarms(): 
 **/
void		CxDaemonMgr::showAlarms(QList<KOEvent> &alarmEvents) {

	if(alarmEvents.isEmpty());
}

/**
 ** CxDaemonMgr::reloadCal(): 
 **/
void		CxDaemonMgr::reloadCal() {
}

/**
 ** CxDaemonMgr::suspend():
 **/
void		CxDaemonMgr::suspend(int duration) {

	if(duration);
}

/**
 ** CxDaemonMgr::showDialog(): 
 **/
void		CxDaemonMgr::showDialog() {
}

/*******************************************************************
 ** CxDaemon::CxDaemon(): CONSTRUCTOR.
 **/
		CxDaemon::CxDaemon()
		:KUniqueApplication()
		,trayMgr( NULL ) {

	g_dcopClient = dcopClient();
}

/**
 ** CxDaemon::~CxDaemon(): DESTRUCTOR.
 **/
		CxDaemon::~CxDaemon() {
}

/**
 ** CxDaemon::newInstance():
 **/
int		CxDaemon::newInstance() {

	if(trayMgr) return(0);
	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
 
	trayMgr = new CxDaemonMgr(QString::null, 0, "CxDaemonMgr");
 
	return(0);
}
