#ifndef		__CXDAEMON_H__
#define		__CXDAEMON_H__
#include	<kuniqueapp.h>
#include	<kpixmap.h>
#include	<ksystemtray.h>
#include	"cxconnection.h"
#include	"koevent.h"
#include	"wndabout.h"
#include	"wndchat.h"
#include	"wndbuddylist.h"
#include	"cxdaemontray.h"

/**
 ** class CxDaemonMgr: Tray manager.
 **/
class		CxDaemonMgr
		:public QObject, DCOPObject {
Q_OBJECT

public:
		CxDaemonMgr( const QString&, QWidget *, const char *);
virtual		~CxDaemonMgr();

    bool process(const QCString &fun, const QByteArray &data,
                 QCString &replyType, QByteArray &replyData);
 
  public slots:
    void showAlarms(QList<KOEvent> &alarmEvents);
    void reloadCal();
    void suspend(int duration);
    void showDialog();
 
  signals:
    void alarmSignal(QList<KOEvent> &);
 
  private:
    CxDaemonTray *docker;
    QTimer *mSuspendTimer;
};

/**************************************************
 ** class CxDaemon: Handler for the SysTray object.
 **/
class 		CxDaemon 
		:public KUniqueApplication {
Q_OBJECT

public:
		CxDaemon();
virtual		~CxDaemon();

private slots:
	int		newInstance();

protected:
	DCOPClient	*g_dcopClient;
	CxDaemonMgr	*trayMgr;
};

#endif
