#ifndef		__CXDAEMONTRAY_H__
#define		__CXDAEMONTRAY_H__
#include	<kuniqueapp.h>
#include	<kpixmap.h>
#include	<ksystemtray.h>
#include	"cxconnection.h"
#include	"koevent.h"
#include	"wndabout.h"
#include	"wndchat.h"
#include	"wndbuddylist.h"

/**************************************
 ** class CxDaemonTray: SysTray object.
 **/
class 		CxDaemonTray
		:public KSystemTray {
Q_OBJECT

enum CurrentState {
	Offline,
	Online,
	Error,
	Working
};

public:
		CxDaemonTray(QObject *parent = NULL, const char *name = 0L);
virtual		~CxDaemonTray();

	bool		alarmsOn();
	void		addToolTip(const QString&);
	CXLIST		*getFloorCache();

protected:
	void		mousePressEvent(QMouseEvent *);
	void		closeEvent(QCloseEvent *e);

public slots:
	void		toggleAlarmsEnabled();
	void		raiseAboutDlg();
	void		raiseBuddyDlg();
	void		reapBuddyDlg();
	void		raisePrefsDlg();
	void		setIcon( CurrentState );
	void		setIconOnline();
	void		setIconWorking();
	void		setIconNormal();
	void		setIconOffline();
	void		syncLists();

private slots:
	void		launchInfusion();
	void		errorMsg( const QString & );
	void		goOffline();
	void		goOnline();
	void		initConnection();
	void		initIcons();
	void		autoSyncLists();
	void		openChatWin( const QString& );
	void		closeChatWin( const QString& );

protected:
	CxWndChat	&chatWin(const QString&); 

	CxConnection	*g_cxConxion;

	KPixmap		pix1;
	KPixmap 	pix2;
	KPixmap 	pix3;
	int		itemId, refreshId;
	bool		g_isWorking;

	CxWndBuddylist	*w_buddyList;
	QDict<CxWndChat>
			w_chatWindows;
};

#endif
