/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: daemon.o
 ** Date: 2000-03-08
 ** Last Revision: 2001-03-08
 ** Description: Infusion Daemon main interface.
 ** CVS: $Id: daemon.cpp,v 1.5 2001/06/12 15:03:17 brian Exp $
 **/
extern "C" {
     #include <stdio.h>
     #include <stdlib.h>
}
#include	<iostream.h>
#include	<kapp.h>
#include	<kconfig.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#include	<klocale.h>
#include	<dlfcn.h>
#include	<CxClient.h>
#include	<qstring.h>
#include	"rfc2426.h"
#include	"sysmgmt.h"
#include	"cxdaemon.h"
#include	"autoconf.h"

MGMTINFO	g_CxMgtInfo;
CxDaemon	*g_CxDaemon;

void		CxRegisterCallbacks();

/**
 ** Initialize module
 **/ 
int		main(int argc, char *args[]) {
MGMTINFO	*minfo;
char		buf[255];

	if(!getenv("DISPLAY")) {
		cout << "* * *  Unable to start Infusion Daemon!  * * *" << endl;
		cout << "Please verify that you are running the X Windowing System, and" << endl;
		cout << "ensure that your DISPLAY environment variable is properly set." << endl;
		exit(0);
	}


	KLocale::setMainCatalogue("infusiond");
	KAboutData      CxAbout(
                        I18N_NOOP("infusiond"),
                        I18N_NOOP("Infusion Daemon"),
                        VERSION,
                        I18N_NOOP("Infusion Groupware Client Connection Manager"),
                        KAboutData::License_BSD,
                        "Copyright (c) 2000, SCCG/Flaming Sword Productions",
                        I18N_NOOP("The best communications client in the world!"),
                        "http://www.shadowcom.net/Software/infusion/",
                        "brian@shadowcom.net"
                );

        static KCmdLineOptions options[] = {
                {0, 0, 0}
        };
 
        KCmdLineArgs::init(argc,args,&CxAbout);
	KCmdLineArgs::addCmdLineOptions(options);
	KUniqueApplication::addCmdLineOptions();

	/**
	 ** Instruct the libCxClient subsystem as to which version of Infusion
	 ** this is.
	 **/
	sprintf(buf, "infusiond %s", VERSION);
	CxClRegClient(buf);

	/**
	 ** Attempt to locate a Citadel/UX Management Server.  If we can find
	 ** one, management information will be loaded into a structure
	 ** which can be referenced by other functions.
	 **/
	minfo = CxMgtRetrieve();
	if(minfo) {
		memcpy(&g_CxMgtInfo, &minfo, sizeof(MGMTINFO));
		free(minfo);
	} else {
		bzero(&g_CxMgtInfo, sizeof(MGMTINFO));
	}

	/**
	 ** Tie our callbacks into the Citadel Session Layer.
	 **/
	CxRegisterCallbacks();

	/**
	 ** Run the Daemon Initialization tasks.
	 **/
	if(!CxDaemon::start()) {
		cout << "* * *  Unable to start Infusion Daemon!  * * *" << endl;
		cout << "It is likely that another copy of the Infusion Daemon is already" << endl;
		cout << "running for your account.  Please close the extra Daemon and try" << endl;
		cout << "running this program again." << endl;
		exit(0);
	}

	CxDaemon a;
	g_CxDaemon = &a;
	a.exec();

	/**
	 ** Shutdown the callback subsystem.
	 **/
	CxClCbShutdown();

	exit(0);
}
