/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: main.o
 ** Date: 2000-10-15
 ** Last Revision: 2001-01-08
 ** Description: KDE2 module interface.
 ** CVS: $Id: main.cpp,v 1.6 2001/03/14 04:51:25 brian Exp $
 **/
extern "C" {
     #include <stdio.h>
     #include <stdlib.h>
}
#include	<iostream.h>
#include	<kapp.h>
#include	<kconfig.h>
#include	<dcopclient.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#include	<klocale.h>
#include	<dlfcn.h>
#include	<CxClient.h>
#include	<qstring.h>
#include	"wndmain.h"
#include	"wndlogin.h"
#include	"rfc2426.h"
#include	"sysmgmt.h"
#include	"autoconf.h"

KApplication	*g_K2App;
CxWndMain	*wndMain;
MGMTINFO	g_CxMgtInfo;

/**
 ** inChatCallback(): This is our hook into the CxClient libraries.
 **/
void    inChatCallback(const char *user, const char *msg) {
        
        cerr << "inChatCallback(): Received." << endl;
        cerr << "user: " << user << endl;
        cerr << "msg: " << msg << endl;
//	wndMain->openChatWindow(QString(user));
}

/**
 ** Initialize module
 **/ 
int		main(int argc, char *args[]) {
MGMTINFO	*minfo;
char		buf[255];

	if(!getenv("DISPLAY")) {
		cout << "* * *  Unable to start Infusion!  * * *" << endl;
		cout << "Please verify that you are running the X Windowing System, and" << endl;
		cout << "ensure that your DISPLAY environment variable is properly set." << endl;
		exit(0);
	}

	KAboutData      CxAbout(
                        I18N_NOOP("Infusion"),
                        I18N_NOOP("Infusion"),
                        "1.0",
                        I18N_NOOP("Infusion Communications System"),
                        KAboutData::License_BSD,
                        "Copyright (c) 2000, SCCG/Flaming Sword Productions",
                        "http://www.shadowcom.net/Software/infusion/",
                        I18N_NOOP("The best communications client in the world!"),
                        "brian@shadowcom.net"
                );

        static KCmdLineOptions options[] = {
                {0, 0, 0}
        };
 
        KCmdLineArgs::init(argc,args,&CxAbout);

        KCmdLineArgs::addCmdLineOptions(options);

	/**
	 ** Instruct the libCxClient subsystem as to which version of Infusion
	 ** this is.
	 **/
	sprintf(buf, "Infusion %s", VERSION);
	CxClRegClient(buf);

	/**
	 ** Attempt to locate a Citadel/UX Management Server.  If we can find
	 ** one, management information will be loaded into a structure
	 ** which can be referenced by other functions.
	 **/
	minfo = CxMgtRetrieve();
	if(minfo) {
		memcpy(&g_CxMgtInfo, &minfo, sizeof(MGMTINFO));
		free(minfo);
	} else {
		bzero(&g_CxMgtInfo, sizeof(MGMTINFO));
	}

	/**
	 ** Register our chat window message handler with libCxClient.
	 **/
	CxMiExpHook(inChatCallback);

	/**
	 ** This is here simply for testing purposes.  If you see this comment,
	 ** or the following lines of code, just close your eyes....
	 **/
//	QString s = "begin:vcard\nn:Brian Ledbetter\nfn:Ledbetter\\, Brian\nversion:1.0\nend:vcard\n";
//	Rfc2426 fubar( s );
 
	KApplication *a = new KApplication;

	wndMain = new CxWndMain();
	a->setMainWidget(wndMain);
	wndMain->show();

	CxWndLogin *dlg = new CxWndLogin(g_K2App, QString("Login"));
	if(!dlg->isCached()) dlg->show();

	a->exec();

	/**
	 ** Shutdown the callback subsystem.
	 **/
	CxClCbShutdown();

	cout << "Thank-you for using Infusion!" << endl;
	cout << "(Sorry for the mess!  It _will_ get better, I promise!  :)" << endl;
}
