/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objaddrbookview.h
 ** Date: 2001-02-26
 ** Last Revision: 2001-02-26
 ** Description: Interface for Address Book View.
 ** CVS: $Id: objaddrbookview.h,v 1.4 2001/03/14 04:51:26 brian Exp $
 **/
#ifndef		__OBJADDRBOOKVIEW_H__
#define		__OBJADDRBOOKVIEW_H__
#include	<qwidget.h>
#include	<qcanvas.h>
#include	<klistview.h>
#include	<kiconloader.h>
#include	<qhbox.h>
#include	<qpopupmenu.h>
#include	<CxClient.h>
#include	"objgenericview.h"

/**
 ** A AddrBookView is a subset of the GenericView object.  It also inherits properties from
 ** a QCanvas.
 **/
class		CxObjAddrBookView: public CxObjGenericView {
friend CxObjGenericView;
Q_OBJECT

public:
			CxObjAddrBookView(QWidget *);

inline	QPixmap		CxSmallIcon() { return(SmallIcon(QString("kab"))); };
inline	QPixmap		CxDesktopIcon() { return(DesktopIcon(QString("kab"),32)); };
inline	QPopupMenu*	CxObjectMenu() { return(NULL); };
inline 	QString		CxObjectName() { return(QString("Contacts")); };
inline 	KToolBar*	CxToolbar() {  return(i_toolBar); };

public slots:
	void		refresh();
	void		clear();

private:
	CXLIST		_MesgIndex, _MesgInfo;
	QString		currentRoom;
	KListView	*myList;
	QPopupMenu	*m_ObjectMenu;
	KToolBar	*i_toolBar;
};

#endif
