/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objcalview.o
 ** Date: 2001-02-19
 ** Last Revision: 2001-02-19
 ** Description: Implementation for Calendar view.
 ** CVS: $Id: objcalview.cpp,v 1.6 2001/03/14 04:51:26 brian Exp $
 **/
#include	<stdlib.h>
#include	<qwidget.h>
#include	<qdatetime.h>
#include	<qtable.h>
#include	<kdatepik.h>
#include	<kdialog.h>
#include	<klistview.h>
#include	<kapp.h>
#include	<qhbox.h>
#include	<klistview.h>
#include	<kiconloader.h>
#include	<qcursor.h>
#include	<qmultilineedit.h>
#include	<qtimer.h>
#include	<qwidgetstack.h>
#include	<qclipboard.h>
#include	<kglobal.h>
#include	<kdebug.h>
#include	<kiconloader.h>
#include	<kstddirs.h>
#include	<kstdaccel.h>
#include	<kfiledialog.h>
#include	<kmessagebox.h>
#include	<knotifyclient.h>
#include	<CxClient.h>
#include	"koevent.h"
#include	"koagendaview.h"
#include	"kdatenav.h"
#include	"calobject.h"
#include	"calendarlocal.h"
#include	"calprinter.h"
#include	"calfilter.h"
#include	"vcaldrag.h"
#include	"icalformat.h"
#include	"vcalformat.h"
#include	"scheduler.h"
#include	"wndmain.h"
#include	"objcalview.h"
#include	"objtasklist.h"

extern CxWndMain *wndMain;

#define		LIST_VIEW	0
#define		DAY_VIEW	1
#define		WEEK5_VIEW	2
#define		WEEK7_VIEW	3
#define		MONTH_VIEW	4

/**
 ** CxObjCalendarView::~CxObjCalendarView(): DESTRUCTOR.
 **/
		CxObjCalendarView::CxObjCalendarView(QWidget *parent,const char *name)
		:CxObjGenericView( parent ) {

	CalObject *mCalendar = new CalendarLocal;

	QBoxLayout *topLayout = new QVBoxLayout(this);

	// create the main layout frames.
	QSplitter *mPanner = new QSplitter(QSplitter::Horizontal,this,"CalendarView::Panner");
	topLayout->addWidget(mPanner);

	i_leftPane = new QWidgetStack( mPanner );
	QSplitter *mRightPane = new QSplitter( QSplitter::Vertical, mPanner );

	QHBox *dateFrame = new QHBox( mRightPane );
	dateFrame->setFrameShape( QFrame::WinPanel );
	dateFrame->setFrameShadow( QFrame::Sunken );
	KDateNavigator *mDateNavigator;
	mDateNavigator = new KDateNavigator( dateFrame, mCalendar, true, 0 );
	_taskList = new CxObjTasklist( mRightPane );

	KOMonthView *mMonthView = new KOMonthView( mCalendar, i_leftPane, "CxObjCalendarView::KOMonthView" );
	i_leftPane->addWidget(mMonthView, 0);

	KOAgendaView *mAgendaView = new KOAgendaView( mCalendar, i_leftPane, "CxObjCalendarView::KOAgendaView" );
	i_leftPane->addWidget(mAgendaView, 1);

	i_leftPane->raiseWidget(mMonthView);
//	i_leftPane->raiseWidget(mAgendaView);
}

/**
 ** CxObjCalendarView::~CxObjCalendarView(): DESTRUCTOR.
 **/
		CxObjCalendarView::~CxObjCalendarView() {
  hide();
}

/**
 ** CxObjCalendarView::makeToolBar(): 
 **/
void		CxObjCalendarView::makeToolBar( KToolBar *tb) {

	KGlobal::iconLoader()->addAppDir("infusion");
	tb->setFullSize( false );

	tb->insertButton( SmallIcon(QString("1day")), DAY_VIEW, SIGNAL(pressed()), this, SLOT(dayView()), true, QString("Day"), -1);
	tb->insertButton( SmallIcon(QString("5days")), WEEK5_VIEW, true, QString("Work Week"), -1);
	tb->insertButton( SmallIcon(QString("7days")), WEEK7_VIEW, true, QString("Week"), -1);
	tb->insertButton( SmallIcon(QString("month")), MONTH_VIEW, true, QString("Month"), -1);
	i_toolBar = tb;
}

/**
 ** CxObjCalendarView::refresh(): Refresh the message list.
 **/
void		CxObjCalendarView::refresh() {

	_taskList->refreshList();        
}

/**
 ** CxObjCalendarView::clear(): Clear the CalendarView.
 **/
void		CxObjCalendarView::clear() {
}

/**
 ** CxObjCalendarView::dayView(): 
 **/
void		CxObjCalendarView::dayView() {

	i_leftPane->raiseWidget( i_agendaView );
}
