/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objcalview.h
 ** Date: 2001-02-19
 ** Last Revision: 2001-02-19
 ** Description: Interface for Calendar View.
 ** CVS: $Id: objcalview.h,v 1.6 2001/03/14 04:51:27 brian Exp $
 **
 ** Contains code from the KOrganizer project, protected under
 ** the GNU PUBLIC LICENSE.  Please see the end of this file
 ** for details.
 **/
#ifndef		__OBJCALENDARVIEW_H__
#define		__OBJCALENDARVIEW_H__
#include	<qframe.h>
#include	<qlayout.h>
#include	<qwidget.h>
#include	<qwidgetstack.h>
#include	<qlist.h>
#include	<qframe.h>
#include	<qsplitter.h>
#include	<qvbox.h>
#include	<kiconloader.h>
#include	<kdatepik.h>
#include	<klistview.h>
#include	<CxClient.h>

#include	"scheduler.h"
#include	"koevent.h"
#include	"calobject.h"
#include	"calprinter.h"
#include	"calfilter.h"
#include	"kolistview.h"
#include	"kotodoview.h"
#include	"komonthview.h"
#include	"koagendaview.h"
#include	"kobaseview.h"
#include	"objgenericview.h"
#include	"objtasklist.h"

/**
 ** With this class, I am experimenting with some standardization
 ** abstractions.  I hope to generalize a View class which can be
 ** overridden with neat niftiness, and provide users with the
 ** ability to extend Infusion.  I am using this rudimentary object
 ** to hash out my ideas.  It will dramatically change once I figure
 ** out how I'm gonna do this... -b
 **/
class		KOEvent;
class		CxObjCalendarView: public CxObjGenericView {
friend CxObjGenericView;
Q_OBJECT

public:
enum EventAction { 
	EVENTADDED, 
	EVENTEDITED, 
	EVENTDELETED 
};
  

			CxObjCalendarView(QWidget *parent=0, const char *name=0 );
	virtual 	~CxObjCalendarView();

inline	QPixmap		CxSmallIcon() { return(SmallIcon(QString("karm"))); };
inline	QPixmap		CxDesktopIcon() { return(DesktopIcon(QString("karm"),32)); };
inline	QPopupMenu*	CxObjectMenu() { return(NULL); };
inline 	QString		CxObjectName() { return(QString("Calendar")); };
inline 	KToolBar*	CxToolbar() {  return(i_toolBar); };
	void		makeToolBar( KToolBar* );

public slots:
	void		refresh();
	void		clear();
	void		dayView();

private:

	CXLIST		_MesgIndex, _MesgInfo;
	QString		currentRoom;
	KListView	*myList;
	CxObjMesgPane	*myMesgPane;
	QPopupMenu	*m_ObjectMenu;
	KToolBar	*i_toolBar;

	QWidgetStack	*i_leftPane;
	KOAgendaView	*i_agendaView;

	CxObjTasklist	*_taskList;
};

#endif

/**
 ** ** NOTICE OF OPENSOURCE USAGE **
 **
 ** Most of the technology in this class was provided by the KOrganizer team, whom I deeply thank
 ** for their widgets.  I would not have had a clue where to start with this widget set if it weren't
 ** for the rich example provided by their code.  If you don't need the rich groupware backend that 
 ** Infusion provides, KOrganizer is a nice alternative.  Thanks, guys!! :)
 **
 ** Because the source of this widget is from a GPL'ed project, you are REQUIRED to redistribute the 
 ** source code for this file if you change it for use with any of your projects!  Please refer to the
 ** GPL for additional information ('cuz I'm not a lawyer, and if you don't, you'll NEED one...)
 **
 ** * KOCalendarView
 ** * This file is part of the KOrganizer project.
 ** * (c) 1999 Preston Brown <pbrown@kde.org>
 ** Source:	 $KOrganizer: calendarview.h,v 1.19 2001/01/14 11:20:07 cschumac Exp $
 **/
