/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/objfolderlist.o
 ** Date: 2000-12-11
 ** Last Revision: 2000-12-11
 ** Description: Folder list component.
 ** CVS: $Id: objfolderlist.cpp,v 1.8 2001/05/16 22:40:43 brian Exp $
 **/
#define         __CX_SOURCEFILE__
extern "C" {
#include	<stdlib.h>
};
#include        <iostream.h>
#include        <qlayout.h>
#include        <qevent.h>
#include        <qhbox.h>
#include        <kapp.h>
#include        <kglobal.h>
#include        <kmessagebox.h>
#include        <kiconloader.h>
#include        <klistview.h>
#include        <CxClient.h>
#include	"objfolderlist.h"
#include	"wndmain.h"
extern CxWndMain *wndMain;

#include	"icons/folder_16x16.xpm"
#include	"icons/drives_16x16.xpm"

static
char    *g_Ser[10];
 
/**
 ** _serialize(): Take a pipe-separated string & convert it into a 2-dimensional
 ** array.
 **/
static
void            _serialize(char *s) {
char            **ap, *argv[10], *end;
int             i;
 
 
        for (ap = argv; (*ap = (char *)strsep(&s, "|")) != NULL;) {
                if (++ap >= &argv[10]) {
                        break;
                }
        }
        end = (char *)(ap - 1);
 
        i = 0;
        for(ap=&argv[0]; (char *)ap <= end; ap++) {
                g_Ser[i] = *ap;
                i++;
        }
        g_Ser[i] = 0;
}

/**
 ** CxObjFolderList::CxObjFolderList(): Constructor.
 **/
		CxObjFolderList::CxObjFolderList(QWidget *parent, int mode, const QString& searchSpec, const char *name): 
		KListView(parent, name) {

	if(mode);
	if(searchSpec);

	connect(this, SIGNAL(executed( QListViewItem* )), SLOT(slotSelected( QListViewItem* )));
	setFrameStyle( QFrame::WinPanel + QFrame::Sunken );
	addColumn( QString("Folder List") );
	setAllColumnsShowFocus( true );
	setRootIsDecorated( true );
	setSorting( -1 );
	setAcceptDrops( false );
	setDragEnabled( false );
	setMinimumWidth( 0 );

	_RoomIndex = _FloorIndex = 0;
}

/**
 ** CxObjFolderList::refreshList(): Refresh the user listing.  This will behave
 ** differently depending on which mode the selector is in.
 **/
void		CxObjFolderList::refreshList() {
CXLIST		x = 0,y = 0;
QListViewItem   *i, *ii, *iii;
char            fid[10];
char            buf[255], buf2[255];
 
	clear();

        buf[0] = buf2[0] = 0;
 
	i = new QListViewItem(this, QString("Personal Folders"));
	i->setPixmap(0, QPixmap( drives_16x16_xpm ));
	i->setOpen(true);
 
	ii = new QListViewItem(i, QString("Calendar"));
	ii->setPixmap(0, SmallIcon(QString("karm")));
 
	ii = new QListViewItem(i, QString("Contacts"));
	ii->setPixmap(0, SmallIcon(QString("ktalkd")));
 
	ii = new QListViewItem(i, QString("Deleted Items"));
	ii->setPixmap(0, SmallIcon(QString("trashcan_empty")));
 
	ii = new QListViewItem(i, QString("Inbox"));
	ii->setPixmap(0, SmallIcon(QString("kword")));
 
	ii = new QListViewItem(i, QString("Journal"));
	ii->setPixmap(0, SmallIcon(QString("korganizer")));
 
	ii = new QListViewItem(i, QString("Notes"));
	ii->setPixmap(0, SmallIcon(QString("knotes")));
 
	ii = new QListViewItem(i, QString("Outbox"));
	ii->setPixmap(0, SmallIcon(QString("folder_open")));
 
	ii = new QListViewItem(i, QString("Sent Items"));
	ii->setPixmap(0, SmallIcon(QString("folder")));
 
	ii = new QListViewItem(i, QString("Tasks"));
	ii->setPixmap(0, SmallIcon(QString("klipper")));

	if(!_FloorIndex) {
		_FloorIndex = CxFlList( wndMain->getHndl() );
	}
 
	if(!_RoomIndex) {
		_RoomIndex = CxRmList( wndMain->getHndl() );
	}
 
	i = new QListViewItem(this, QString("Mailbox - ")+wndMain->getUserNameQs());
	i->setPixmap(0, QPixmap( folder_16x16_xpm ));
 
	ii = new QListViewItem(i, QString("Mail Inbox"));
	ii->setPixmap(0, SmallIcon(QString("kwrite")));                                                                                                      
	iii = new QListViewItem(this, QString("Public Folders"));
	iii->setPixmap(0, QPixmap( drives_16x16_xpm ));

	x = _FloorIndex;
	while(x) {
		strcpy(buf,x->data);
 
		_serialize(buf);
		strcpy(fid, g_Ser[0]);
 
		ii = new QListViewItem(i, QString(g_Ser[1]));
		ii->setPixmap(0,QPixmap( folder_16x16_xpm ));
		if(!strcmp(fid,"0")) ii->setOpen(true);
 
		y = _RoomIndex;
		while(y) {
			strcpy(buf2, y->data);
			_serialize(buf2);
			if(!strcmp(fid, g_Ser[2])) {
				if(strcmp(g_Ser[0], "Mail")) {
					iii = new QListViewItem(ii, QString(g_Ser[0]));
					iii->setPixmap(0, QPixmap( folder_16x16_xpm ));
				}
			}
			y = y->next;
		}
 
		x = x->next;
	}

}

/**
 ** CxObjFolderList::resizeEvent(): Return a pointer to the selected row.
 **/
void		CxObjFolderList::resizeEvent(QResizeEvent *qre) {

	KListView::resizeEvent(qre);
	setColumnWidth(0, width()-4);
}

/**
 ** CxObjFolderList::selectedItem(): Return a pointer to the selected row.
 **/
void		CxObjFolderList::slotSelected(QListViewItem *i) {

	if(!i->childCount()) {
		if(i->parent()->text(0) == "Personal Folders") {

			// FIXME: This is not very language-insensitive... Will need to fix later.
			if(i->text(0) == "Inbox") {
				emit wndMain->slotKoolBar(0, 1);

			} else if(i->text(0) == "Calendar") {
				emit wndMain->slotKoolBar(0, 2);

			} else if(i->text(0) == "Contacts") {
				emit wndMain->slotKoolBar(0, 3);

			} else if(i->text(0) == "Tasks") {
				emit wndMain->slotKoolBar(0, 4);

			} else if(i->text(0) == "Notes") {
				emit wndMain->slotKoolBar(0, 6);
			}
		} else {
			emit wndMain->gotoRoom(i->text(0));
		}
	}
}
