/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objfolderview.h
 ** Date: 2001-02-15
 ** Last Revision: 2001-02-15
 ** Description: Implementation for folder view.
 ** CVS: $Id: objfolderview.cpp,v 1.7 2001/05/16 22:40:43 brian Exp $
 **/
extern "C" {
#include	<stdlib.h>
}
#include	<qwidget.h>
#include	<qdatetime.h>
#include	<klistview.h>
#include	<kapp.h>
#include	<qsplitter.h>
#include	<klistview.h>
#include	<kiconloader.h>
#include	<CxClient.h>
#include	"wndmesg.h"
#include	"wndmain.h"
#include	"objfolderview.h"
#include	"objmesgpane.h"

#include	"icons/mail_new_16x16.xpm"
#include	"icons/mail_old_16x16.xpm"

extern CxWndMain *wndMain;

static
char    *g_Ser[10];

/**
 ** _serialize(): Take a pipe-separated string & convert it into a 2-dimensional
 ** array.
 **/
static
void            _serialize(char *s) {
char            **ap, *argv[10], *end;
int             i;


        for (ap = argv; (*ap = (char *)strsep(&s, "|")) != NULL;) {
                if (++ap >= &argv[10]) {
                        break;
                }
        }
        end = (char *)(ap - 1);

        i = 0;
        for(ap=&argv[0]; (char *)ap <= end; ap++) {
                g_Ser[i] = *ap;
                i++;
        }
        g_Ser[i] = 0;
}

/**
 ** CxObjFolderView::CxObjFolderView(): Constructoir
 **/
		CxObjFolderView::CxObjFolderView(QWidget *parent) : QSplitter(Vertical, parent) {

	myList = new KListView(this);
        connect(myList, SIGNAL(clicked( QListViewItem* )),
                SLOT(slotSelected( QListViewItem* )));
        connect(myList, SIGNAL(doubleClicked( QListViewItem* )),
                SLOT(slotOpenMesg( QListViewItem* )));
        myList->setAllColumnsShowFocus(true);
        myList->setFrameStyle(QFrame::WinPanel + QFrame::Sunken);
        myList->addColumn("MsgID");
        myList->addColumn("");
        myList->addColumn("Author");
        myList->addColumn("Date");
        myList->addColumn("Subject");
        myList->addColumn("");
        myList->setSorting(6);
        myList->setAcceptDrops(false);
        myList->setDragEnabled(false);
        myList->setColumnWidth(0,0);
        myList->setColumnWidth(1,16);
        myList->setColumnWidth(5,0);
        myList->setColumnWidthMode(0, QListView::Manual);
        myList->setColumnWidthMode(4, QListView::Maximum);
        myList->setColumnWidthMode(5, QListView::Manual);
	setResizeMode(myList, QSplitter::KeepSize);

	myMesgPane = new CxObjMesgPane(this);
	setResizeMode(myMesgPane, QSplitter::Stretch);

	currentRoom = QString("_MAIL_");
	_MesgIndex = _MesgInfo = _Unread = 0;
}

/**
 ** CxObjFolderView::refresh(): Refresh the message list.
 **/
void		CxObjFolderView::refresh() {
CXLIST          x = 0 ,y = 0, z = 0;
char            buf[255];
QListViewItem   *i;
QDateTime       td;
int		new_message = 0;
        
	kapp->setOverrideCursor(waitCursor);
        
	if(currentRoom.isEmpty()) {
		ROOMINFO *ri = CxRmGoto(wndMain->getHndl(), "_MAIL_",0);
		if(ri) {
			currentRoom = QString(ri->name);
			free(ri);
		} else return;
	}
       
	if(_MesgIndex) _MesgIndex = CxLlFlush(_MesgIndex);
	if(_MesgIndex) _MesgInfo = CxLlFlush(_MesgInfo);
	if(_Unread) _Unread = CxLlFlush(_Unread);

	_MesgIndex = CxMsList(wndMain->getHndl(), MSGS_ALL, 0);
	_MesgInfo = CxMsInfo(wndMain->getHndl(), _MesgIndex);
	_Unread = CxMsList(wndMain->getHndl(), MSGS_NEW, 0);

	myList->clear();

	x = _MesgInfo;
	y = _MesgIndex;
	while( x ) {
		strcpy(buf, x->data);
		_serialize(buf);
		td.setTime_t(atoi(g_Ser[1]));

		i = new QListViewItem(myList, 
				QString(y->data), 
				QString::null, 
				g_Ser[0], 
				td.toString(), 
				((g_Ser[2][0])?g_Ser[2]:"No Subject"), g_Ser[1]);

		/**
		 ** Check to see if this is a new message.
		 **/
		z = _Unread;
		new_message = 0;
		while( z ) {
			if(!strcmp(y->data, z->data)) new_message = 1;
			z = z->next;
		}

		if(new_message) {
			i->setPixmap(1,QPixmap(mail_new_16x16_xpm));
		} else {
			i->setPixmap(1,QPixmap(mail_old_16x16_xpm));
		}
		x = x->next;
		y = y->next;
	}
	_MesgInfo = CxLlFlush(_MesgInfo);

        /** ** This may be killing my bunghole. **
	if(_FileIndex) _FileIndex = CxLlFlush(_FileIndex);
        _FileIndex = CxFiIndex(wndMain->getHndl());
        x = _FileIndex;
        while( x ) {
                strcpy(buf, x->data);
                _serialize(buf);
                sprintf(buf2, "FILE:%s", g_Ser[0]);
                i = new QListViewItem(lstMesg, buf2, g_Ser[0], g_Ser[1], g_Ser[2]);
                i->setPixmap(1, SmallIcon(QString("filenew")));
                x = x->next;
        }
        **/

	kapp->restoreOverrideCursor();
}

/**
 ** CxObjFolderView::slotLoadMessage(): Load a message.  Duh. :)
 **/
void		CxObjFolderView::slotLoadMessage(const QString &room, const QString &messageId) {
MESGINFO	*mi;

	if(messageId);

	if(currentRoom != room) {
		ROOMINFO *ri = CxRmGoto( wndMain->getHndl(), room.ascii(), 0);
		if(ri) {
			currentRoom = QString(ri->name);
			free(ri);
		} else return;
	}

	mi = 0;
}

/**
 ** CxObjFolderView::slotOpenMesg(): What happens when an item is
 ** selected?
 **/
void		CxObjFolderView::slotOpenMesg(QListViewItem *item) {
MESGINFO        m;

	if(!item) return;
	if(!item->text(0)) return;
	if(!item->text(0).ascii()) return;
	if(!*item->text(0).ascii()) return;

	const char *s = item->text(0).ascii();
	m.body = 0;

	if(!CxMsLoad(wndMain->getHndl(), s, 1, &m)) {
		CxWndMesg *msg = new CxWndMesg(QString(m.rcpt), QString(m.subject), QString(m.room), QString(m.body), false);
		msg->show();
		free(m.body);
		m.body = 0;
	}
}

/**
 ** CxObjFolderView::slotSelected(): What happens when we select an item?
 **/
void            CxObjFolderView::slotSelected(QListViewItem *item) {
MESGINFO        m;
        
	if(!item) return;
	if(!item->text(0)) return;
	if(!item->text(0).ascii()) return;
	if(!*item->text(0).ascii()) return;
        
	const char *s = item->text(0).ascii();
	m.body = 0;

	if(!CxMsLoad(wndMain->getHndl(), s, 1, &m)) {
		QString mbody;
		if(m.body) mbody = QString(m.body);
		else mbody = QString::null;

		emit myMesgPane->slotLoadMesg(QString(m.author), QString(m.rcpt), QString(m.subject), mbody);

		if(m.body) free(m.body);
	}
}

/**
 ** CxObjFolderView::slotTogglePane(): Toggle the pane.
 **/
void		CxObjFolderView::slotTogglePane() {

	if(!isVisible()) return;

	if(myMesgPane->isVisible()) myMesgPane->hide();
	else myMesgPane->show();
}

/**
 ** CxObjFolderView::clear(): Clear the FolderView.
 **/
void		CxObjFolderView::clear() {
	emit myList->clear();
	emit myMesgPane->clear();
}
