/**
 ** infusion - The Desktop Communications Revoution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objgenericview.h
 ** Date: 2001-02-19
 ** Last Revision: 2001-02-19
 ** Description: This is a generic interface to a View (Pane) object.
 ** CVS: $Id: objgenericview.h,v 1.2 2001/02/22 23:06:56 brian Exp $
 **/
#ifndef		__OBJGENERICVIEW_H__
#define		__OBJGENERICVIEW_H__
#include	<qwidget.h>
#include	<ktoolbar.h>
#include	<qpopupmenu.h>
#include	<qhbox.h>
#include	<CxClient.h>
#include	"objmesgpane.h"

/**
 ** With this class, I am experimenting with some standardization
 ** abstractions.  I hope to generalize a View class which can be
 ** overridden with neat niftiness, and provide users with the
 ** ability to extend Infusion.  I am using this rudimentary object
 ** to hash out my ideas.  It will dramatically change once I figure
 ** out how I'm gonna do this... -b
 **
 ** [Class CxObjGenericView]
 **  Method smallIcon(): Return this object's Small icon.
 **  Method desktopIcon(): Return this object's Normal icon.
 **  Method objectMenu(): Return this object's menu (the M_OBJECT menu).
 **  Method objectName(): Return this object's title/name.
 **  Method refresh(): Refresh the contents of the current object.
 **  Method clear(): Clear the contents of the current object.
 **/
class		CxObjGenericView: public QHBox {
Q_OBJECT

public:
				CxObjGenericView(QWidget *parent);

 virtual QPixmap		CxSmallIcon();
 virtual QPixmap		CxDesktopIcon();
 virtual QPopupMenu*		CxObjectMenu();
 virtual QString		CxObjectName();
 virtual KToolBar*		CxToolbar();

public slots:
 virtual	void		refresh();
 virtual	void		clear();
};

#endif
