/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: objtasklist.o
 ** Date: 2001-01-18
 ** Last Revision: 2001-01-18
 ** Description: Task list component.
 ** CVS: $Id: objtasklist.cpp,v 1.9 2001/05/16 22:40:44 brian Exp $
 **/
#define         __CX_SOURCEFILE__
extern "C" {
#include	<stdlib.h>
};
#include        <iostream.h>
#include        <qlayout.h>
#include        <qevent.h>
#include        <qtable.h>
#include        <qhbox.h>
#include        <kapp.h>
#include        <kglobal.h>
#include        <kmessagebox.h>
#include        <kiconloader.h>
#include        <CxClient.h>
#include	"objtasklist.h"
#include	"wndmain.h"
#include	"wndtask.h"
#include	"rfc2426t.h"

#include	"icons/tasks_16x16.xpm"
#include	"icons/checkbox_off_16x16.xpm"
#include	"icons/checkbox_on_16x16.xpm"
extern CxWndMain *wndMain;

/**
 ** CxObjTasklist::CxObjTasklist(): Constructor.
 **/
		CxObjTasklist::CxObjTasklist(QWidget *parent, int mode, const QString& searchSpec, const char *name): 
		QListView(parent, name) {

	if(mode) ;
	if(name) ;
	if(searchSpec) ;

	connect(this, SIGNAL(clicked( QListViewItem* )), SLOT(slotSelected( QListViewItem* )));
	connect(this, SIGNAL(doubleClicked( QListViewItem* )), SLOT(slotOpenItem( QListViewItem* )));

	setFrameStyle(QFrame::WinPanel + QFrame::Sunken);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString::null);
	addColumn(QString("Subject"));
	addColumn(QString("Due Date"));
	setColumnWidth(0,0);
	setColumnWidth(1,0);
	setColumnWidthMode(0,Manual);
	setColumnWidthMode(1,Manual);

	connect( this, SIGNAL(rightButtonPressed(QListViewItem *, const QPoint &, int)), this, SLOT(rmbClicked(QListViewItem *, const QPoint &, int)) );

	m_NoItem = new QPopupMenu(this);
	m_NoItem->insertItem(SmallIcon(QString("klipper")), QString("New &Task..."), this, SLOT(slotNewTask()));

	m_Item = new QPopupMenu(this);
	m_Item->insertItem(QString("&Open"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("For&ward"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("Assi&gn Task"), NULL);
	m_Item->insertItem(QString("&Mark Complete"), NULL);
	m_Item->insertItem(QString("S&end Status Report"), NULL);
	m_Item->insertSeparator();
	m_Item->insertItem(QString("&Delete"), NULL);

	_TaskList = 0;
}

/**
 ** CxObjTasklist::refreshList(): Refresh the user listing.  This will behave
 ** differently depending on which mode the selector is in.
 **/
void		CxObjTasklist::refreshList() {
CXLIST		x;
QListViewItem 	*i;
ROOMINFO	*ri;

	clear();

	ri = CxRmGoto(wndMain->getHndl(), "My Tasks",0);
        if(ri) {
		free(ri);
		if(_TaskList) _TaskList = CxLlFlush(_TaskList);

		_TaskList = CxMsList(wndMain->getHndl(), MSGS_ALL, 0);
		x = _TaskList;
		while(x) {
			MESGINFO msg;
			msg.body = 0;

			if(!CxMsLoad(wndMain->getHndl(), x->data, 0, &msg)) {
				Rfc2426t *t = new Rfc2426t(msg.body);

				if(t) {
					i = new QListViewItem(this, 
						QString( (((t->getStatus())==100)?"1":"0") ),
						QString(x->data),
						QString::null,
						QString::null,
						t->getSubject(),
						QString("01/01 01:01"));
					i->setPixmap(2, QPixmap(tasks_16x16_xpm));
					i->setPixmap(3, 
						QPixmap( (((t->getStatus()==100)?checkbox_on_16x16_xpm:checkbox_off_16x16_xpm) ))
					);

					delete t;
				}
				free(msg.body);
			}

			x = x->next;
		}

		ri = CxRmGoto(wndMain->getHndl(), wndMain->getRoomName(), 0);
		free(ri);

	} else {
                ROOMINFO nri;
                strcpy(nri.name, "My Tasks");
                nri.mode = 4;
                nri.floor_id = 0;
 
                if(CxRmCreate(wndMain->getHndl(), nri)) {
/** OLD CODE **
			i = new QListViewItem(this, QString::null, QString::null, QString::null, QString::null, QString("*** No \"My Tasks\" folder found! ***"));
 **/
                }
	}
}

/**
 ** CxObjTasklist::selectedItem(): Return a pointer to the selected row.
 **/
void		CxObjTasklist::slotSelected(QListViewItem *i) {

	if(!i) return;

	if(i->text(0)=="1") {
		i->setText(0, QString("0"));
		i->setPixmap(3,QPixmap(checkbox_off_16x16_xpm));

	} else {
		i->setText(0, QString("1"));
		i->setPixmap(3,QPixmap(checkbox_on_16x16_xpm));
	}
}

/**
 ** CxObjTasklist::slotNewTask(): Popup new task window.
 **/
void		CxObjTasklist::slotNewTask() {

	CxWndTask *task = new CxWndTask(1);
	task->show();
}

/**
 ** CxObjTasklist::slotLoadTask(): OPEN A TASK.
 **/
void		CxObjTasklist::slotLoadTask(const QString& task_id) {
ROOMINFO	*rmb = 0;
MESGINFO	msg;

	if(wndMain->getRoomName() != "My Tasks") {
		rmb = CxRmGoto(wndMain->getHndl(), "My Tasks",0);
	}

	msg.body = 0;

	if(!CxMsLoad(wndMain->getHndl(), task_id, 0, &msg)) {
		Rfc2426t *t = new Rfc2426t(msg.body);

		if(t) {

			CxWndTask *taskwin = new CxWndTask(0, t);
			taskwin->show();

			delete t;
		}
		free(msg.body);
	}
	

	if(rmb) {
		free(rmb);
		rmb = CxRmGoto(wndMain->getHndl(), wndMain->getRoomName(),0);
		free(rmb);
	}
}

/**
 ** CxObjTasklist::slotOpenItem(): OPEN A TASK.
 **/
void		CxObjTasklist::slotOpenItem(QListViewItem *item) {

	emit slotLoadTask(item->text(1));
}

/**
 ** CxObjTasklist::rmbClicked(): What happens when a user right-clicks?  (CONTEXT-SENSITIVE MENU)
 **/
void		CxObjTasklist::rmbClicked(QListViewItem *item, const QPoint &pt, int x) {

	if(x) ;
	if(!item) {
		m_NoItem->popup(pt);
		return;

	} else {
		emit QListView::selectionChanged(item);
		m_Item->popup(pt);
		return;
	}
}
