/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/wndmain.c
 ** Date: 2000-11-09
 ** Last Revision: 2000-11-09
 ** Description: Main user interface window.
 ** CVS: $Id: wndmain.cpp,v 1.12 2001/05/16 22:40:44 brian Exp $
 **/
extern "C" {
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
};
#include	<iostream.h>
#include	<qlayout.h>
#include	<qframe.h>
#include	<qwidgetstack.h>
#include	<qdatetime.h>
#include	<qwindowsstyle.h>
#include	<qsplitter.h>
#include	<kapp.h>
#include	<kaccel.h>
#include	<kglobal.h>
#include	<klocale.h>
#include	<kmessagebox.h>
#include	<dcopclient.h>
#include	<kiconloader.h>
#include	<kstddirs.h>
#include	<ktoolbarbutton.h>
#include	<kconfig.h>
#include	<knotifyclient.h>
#include	<kwin.h>
#include	<CxClient.h>
#include	"autoconf.h"
#ifdef		HAVE_KOOLBAR
#include	"koKoolBar.h"
#endif
#include	"objtitlebar.h"
#include	"objuserlist.h"
#include	"objnotesview.h"
#include	"objaddrbookview.h"
#include	"objtasklist.h"
#include	"objcalview.h"
#include	"objnote.h"
#include	"wndabout.h"
#include	"wndaction.h"
#include	"wndlogin.h"
#include	"wndmesg.h"
#include	"wndtask.h"
#include	"wndmain.h"

#include	"icons/folder_32x32.xpm"

#define		ID_NEW		1
#define		ID_NEXT		2
#define		ID_REFRESH	3
#define		ID_BUDDYLIST	4

extern	KApplication *g_K2App;
extern	CxWndAction	*wndAction;

static
char	*g_Ser[10];

/**
 ** _serialize(): Take a pipe-separated string & convert it into a 2-dimensional
 ** array.
 **/
static
void            _serialize(char *s) {
char            **ap, *argv[10], *end;
int             i;
 
 
        for (ap = argv; (*ap = (char *)strsep(&s, "|")) != NULL;) {
                if (++ap >= &argv[10]) {
                        break;
                }
        }
        end = (char *)(ap - 1);
 
        i = 0;
        for(ap=&argv[0]; (char *)ap <= end; ap++) {
                g_Ser[i] = *ap;
                i++;
        }
        g_Ser[i] = 0;
}

/**
 ** CxWndMain::Constructor()
 **/
		CxWndMain::CxWndMain() : KTMainWindow() {
int		i;

	KWin::setIcons(winId(), DesktopIcon("infusion"), SmallIcon(QString("infusion")));
	Room[0] = Connected = 0;
	_RoomIndex = _FloorIndex = 0;

	setCaption(QString::null);
	setMinimumSize(300,100);

	KAccel *keys = new KAccel(this);
	keys->connectItem(KStdAccel::New, this, SLOT(slotNewMessage()));
	keys->connectItem(KStdAccel::Quit, this, SLOT(slotExit()));
	keys->insertItem(QString("Refresh"), "Refresh", Key_F5);
	keys->insertItem(QString("AboutApp"), "AboutApp", CTRL+Key_A);
	keys->insertItem(QString("Disconnect"), "Disconnect", CTRL+Key_D);
	keys->insertItem(QString("Inbox"), "Inbox", CTRL+Key_1);
	keys->insertItem(QString("Calendar"), "Calendar", CTRL+Key_2);
	keys->insertItem(QString("Contacts"), "Contacts", CTRL+Key_3);
	keys->insertItem(QString("Tasks"), "Tasks", CTRL+Key_4);
	keys->insertItem(QString("Journal"), "Journal", CTRL+Key_5);
	keys->insertItem(QString("Notes"), "Notes", CTRL+Key_6);
	keys->insertItem(QString("DeletedItems"), "DeletedItems", CTRL+Key_7);
	keys->connectItem("AboutApp", this, SLOT(slotAbout()));
	keys->connectItem("Disconnect", this, SLOT(slotDisconnect()));
	keys->connectItem("Inbox", this, SLOT(slotKoInbox()));
	keys->connectItem("Calendar", this, SLOT(slotKoCalendar()));
	keys->connectItem("Contacts", this, SLOT(slotKoContacts()));
	keys->connectItem("Refresh", this, SLOT(slotRefreshVisiblePane()));
	keys->connectItem("Tasks", this, SLOT(slotKoTasks()));
	keys->connectItem("Journal", this, SLOT(slotKoJournal()));
	keys->connectItem("Notes", this, SLOT(slotKoNotes()));
	keys->connectItem("DeletedItems", this, SLOT(slotKoDeleted()));
	keys->readSettings();

	/**
	 ** New "whatever" Button
	 **/
	m_tb_new = new QPopupMenu(this);
	m_tb_new->insertItem(SmallIcon(QString("kword")), QString("New &Message"), this, SLOT(slotNewMessage()));
	m_tb_new->insertItem(SmallIcon(QString("knotes")), QString("New &Note"), this, SLOT(slotNewNote()));
	m_tb_new->insertItem(SmallIcon(QString("klipper")), QString("New &Task"), this, SLOT(slotNewTask()));

	i = toolBar(0)->insertButton(SmallIcon(QString("kword")), ID_NEW, true, QString("New Message"), -1);
	toolBar(0)->setDelayedPopup(i, m_tb_new);
	tb_NewButtonId = i;

	toolBar(0)->insertButton(
		QString("next"), 
		ID_NEXT, 
		true, 
		QString("Goto next folder w/ unread messages"), 
		-1, 
		KGlobal::instance()
	);

	toolBar(0)->insertLineSeparator();
	i = toolBar(0)->insertButton(
		QString("fileprint"), 
		ID_REFRESH, 
		true, 
		QString("Print message"), 
		-1, 
		KGlobal::instance()
	);
	toolBar(0)->setItemEnabled(i,false);
	toolBar(0)->insertButton(
		QString("reload"), 
		ID_REFRESH, 
		true, 
		QString("Refresh message list"), 
		-1, 
		KGlobal::instance()
	);

	toolBar(0)->insertLineSeparator();
	toolBar(0)->insertButton(
		QString("queue"), 
		ID_BUDDYLIST, 
		true, 
		QString("View Buddylist"), 
		-1, 
		KGlobal::instance()
	);

	toolBar(0)->insertLineSeparator();
	i = toolBar(0)->insertButton(
		QString("mail_reply"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply"), 
		-1, 
		KGlobal::instance());
	toolBar(0)->setItemEnabled(i,false);
	i = toolBar(0)->insertButton(
		QString("mail_replyall"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply to All"), 
		-1, 
		KGlobal::instance());
	toolBar(0)->setItemEnabled(i,false);
	i = toolBar(0)->insertButton(
		QString("mail_forward"), 
		ID_BUDDYLIST, 
		true, 
		QString("Reply to All"), 
		-1, 
		KGlobal::instance());
	toolBar(0)->setItemEnabled(i,false);

	emit slotUpdateToolbar();
	toolBar(0)->setFullSize(false);
	connect(toolBar(0), SIGNAL(clicked(int)), this, SLOT(processTbEvent(int)));

	statusBar()->insertItem(QString("Infusion"),0,0,true);
	statusBar()->insertItem(QString("Offline"),1,0,true);
	statusBar()->insertItem(QString("Welcome to Infusion!"),2,1,true);
	statusBar()->setItemAlignment(2, AlignVCenter);

	enableStatusBar(KStatusBar::Show);

	QHBox *hbox = new QHBox(this);
	hbox->setSpacing(3);
	hbox->setMargin(3);

	/**
	 ** This section of code is linked in OPTIONALLY.  It 
	 ** adds a Microsoft Outlook-ish toolbar to the left 
	 ** pane of your Infusion window, but requires a ton 
	 ** of additional libraries (the KOffice-related ones, 
	 ** in particular).  Some users may wish to _not_ use 
	 ** this feature, since it requires libraries which 
	 ** are not traditionally a part of the base KDE 
	 ** distribution.  Et tu, Brute'?
	 **/
#ifdef	HAVE_KOOLBAR

	/**
	 ** Create the KoolBar
	 **/
	i_kbContainer = new QVBox(hbox);
	i_kbContainer->setFrameShape(QFrame::WinPanel);
	i_kbContainer->setFrameShadow(QFrame::Sunken);

	i_koolBar = new KoKoolBar(i_kbContainer);
	i_kbContainer->setFixedWidth(80);

	/**
	 ** Add standard KoolBar group.
	 **/
	i_koolBar->insertGroup(QString("Infusion"));

	/**
	 ** Add standard widgets to group.
	 **/
	i_koolBar->insertItem(0, DesktopIcon("kword",32), 
		QString("Inbox"), this, SLOT(slotKoolBar(int,int)));
	i_koolBar->insertItem(0, DesktopIcon("karm",32), 
		QString("Calendar"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("ktalkd",32), 
		QString("Contacts"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("klipper",32), 
		QString("Tasks"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("korganizer",32), 
		QString("Journal"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("knotes",32), 
		QString("Notes"), this, SLOT(slotKoolBar(int, int)));
	i_koolBar->insertItem(0, DesktopIcon("trashcan_empty",32), 
		QString("Deleted Items"), this, SLOT(slotKoolBar(int, int)));

	i_koolBar->insertGroup(QString("Bookmarks"));
#endif

	QVBox *vbox = new QVBox(hbox);
	vbox->setSpacing(3);

	i_titleBar = new CxObjTitleBar(vbox);
	connect(i_titleBar, SIGNAL(title_clicked()), this, SLOT(slotToggleRooms()));
	emit i_titleBar->slotUpdate(QString("Infusion"), DesktopIcon(QString("mail_generic"),32));

	Shoriz = new QSplitter(QSplitter::Horizontal, vbox);

	/**
	 ** Set up the rooms ("folders") list.
	 **/
	i_folderList = new CxObjFolderList(Shoriz,0,QString::null,"wndMain.objFolderlist");
	Shoriz->setResizeMode(i_folderList, QSplitter::KeepSize);
	i_folderList->setMinimumSize( 0, 0 );

	i_widgetStack = new QWidgetStack( Shoriz );
	i_widgetStack->setMinimumSize( 0, 0 );

	i_notesPane = new CxObjNotesView( i_widgetStack, "wndMain.objNotesPane" );
	//Shoriz->setResizeMode(i_notesPane, QSplitter::Stretch);
	i_widgetStack->addWidget( i_notesPane, 0 );
	i_notesPane->setMinimumSize( 0, 0 );
	i_notesPane->hide();
	
	i_addressPane = new CxObjAddrBookView( i_widgetStack );
	//Shoriz->setResizeMode( i_addressPane, QSplitter::Stretch );
	i_widgetStack->addWidget( i_addressPane, 1 );
	i_addressPane->setMinimumSize( 0, 0 );
	i_addressPane->hide();

	i_tasksPane = new CxObjTasklist( i_widgetStack, 2, "wndMain.objTasksPane" );
	//Shoriz->setResizeMode(i_tasksPane, QSplitter::Stretch);
	i_widgetStack->addWidget( i_tasksPane, 2 );
	i_tasksPane->setMinimumSize( 0, 0 );
	i_tasksPane->hide();

	i_calendarPane = new CxObjCalendarView( i_widgetStack );
	i_calendarPane->makeToolBar( toolBar(1) );
	//Shoriz->setResizeMode(i_calendarPane, QSplitter::Stretch);
	i_widgetStack->addWidget( i_calendarPane, 3 );
	i_calendarPane->setMinimumSize( 0, 0 );
	i_calendarPane->hide();

	i_folderPane = new CxObjFolderView( i_widgetStack );
	//Shoriz->setResizeMode(i_folderPane, QSplitter::Stretch);
	i_widgetStack->addWidget( i_folderPane, 4 );
	i_folderPane->setMinimumSize( 0, 0 );
	i_folderPane->hide();

	i_widgetStack->raiseWidget( i_folderPane );

	connect(i_folderList, SIGNAL(clicked(QListViewItem *)),
			i_folderPane, SLOT(itemSelected(QListViewItem *)));

	setCentralWidget(hbox);

	currentView = CxWndMain::OtherView;

	/**
	 ** MENU: "File"
	 **/
	file = new QPopupMenu();
	QPopupMenu *file_new = new QPopupMenu();

	/**
	 ** MENU: "File"->"New..."
	 **/
	file_new->insertItem(SmallIcon(QString("kword")), QString("&Mail Message"), this, SLOT(slotNewMessage()));
	file_new->insertItem(SmallIcon(QString("knotes")), QString("&Note"), this, SLOT(slotNewMessage()));
	file_new->insertItem(SmallIcon(QString("klipper")), QString("&Task"), this, SLOT(slotNewTask()));

	file->insertItem(SmallIcon(QString("filenew")), QString("&New..."), file_new);
	file->insertSeparator();
	i = file->insertItem(SmallIcon(QString("connect_no")), QString("&Disconnect"), this, SLOT(slotDisconnect()));
	keys->changeMenuAccel(file, i, "Disconnect");
	i = file->insertItem(SmallIcon(QString("exit")), QString("E&xit"), this, SLOT(slotExit()));
	keys->changeMenuAccel(file, i, KStdAccel::Quit);

	/**
	 ** MENU: "View"
	 **/
	view = new QPopupMenu();
	view->setCheckable(true);
	m_id_view_folderlist = view->insertItem(QString("Show Folder List"), this, SLOT(slotToggleRooms()));
	view->setItemChecked(i,i_folderList->isVisible()?true:false);
	m_id_view_mesgpane = view->insertItem(QString("Show Message Pane"), i_folderPane, SLOT(slotTogglePane()));
	/*view->setItemChecked(i,i_mesgPane->isVisible()?true:false);*/
	m_id_view_statusbar = view->insertItem(QString("Show Status Bar"), this, SLOT(slotToggleStatusBar()));
	view->setItemChecked(i,statusBar()->isVisible()?true:false);
#ifdef	HAVE_KOOLBAR
	view->insertItem(QString("Show Infusion Bar"), this, SLOT(slotToggleKoolBar()));
#endif
	i = view->insertItem(SmallIcon(QString("reload")), QString("Check messages..."), i_folderPane, SLOT(refresh()));
	keys->changeMenuAccel(view, i, "Refresh");

	/**
	 ** MENU: "Go"
	 **/
	go = new QPopupMenu();
	i = go->insertItem(SmallIcon(QString("kword")), QString("Inbox"), this, SLOT(slotKoInbox()));
	keys->changeMenuAccel(go, i, "Inbox");
	i = go->insertItem(i_calendarPane->CxSmallIcon(), QString("Calendar"), this, SLOT(slotKoCalendar()));
	keys->changeMenuAccel(go, i, "Calendar");
	i = go->insertItem(SmallIcon(QString("ktalkd")), QString("Contacts"), this, SLOT(slotKoContacts()));
	keys->changeMenuAccel(go, i, "Calendar");
	i = go->insertItem(SmallIcon(QString("klipper")), QString("Tasks"), this, SLOT(slotKoTasks()));
	keys->changeMenuAccel(go, i, "Tasks");
	i = go->insertItem(SmallIcon(QString("korganizer")), QString("Journal"), this, SLOT(slotKoJournal()));
	keys->changeMenuAccel(go, i, "Journal");
	i = go->insertItem(SmallIcon(QString("knotes")), QString("Notes"), this, SLOT(slotKoNotes()));
	keys->changeMenuAccel(go, i, "Notes");
	i = go->insertItem(SmallIcon(QString("trashcan_empty")), QString("Deleted Items"), this, SLOT(slotKoDeleted()));
	keys->changeMenuAccel(go, i, "DeletedItems");

	help = new KHelpMenu(this, QString::null);
	connect( help, SIGNAL(showAboutApplication()), this, SLOT(slotAbout()));

	menu = new KMenuBar(this);
	menu->insertItem("&File", file);
	menu->insertItem("&View", view);
	menu->insertItem("&Go", go);
	menu->insertSeparator();
	menu->insertItem("&Help", help->menu());

	/**
	 ** Set up popup menus.
	 **/
	m_popUp_noItem = new QPopupMenu();
	m_popUp_noItem->insertItem("&New Mail Message...", this, SLOT(slotNewMessage()));

	m_popUp_item = new QPopupMenu();
	m_popUp_noItem->insertItem("&Open", this, SLOT(slotNewMessage()));

	resize(600, 400);

	KConfig * config = KGlobal::config();
	config->setGroup("Geometry");
	applyMainWindowSettings(config);
	readProperties(config);

	/**
	 ** Legacy Citadel/UX protocol compatibility.
	 **/
	QTimer::singleShot( 6000, this, SLOT(checkExpMesg()) );

	/**
	 ** Signal DCOP to start the Infusion Daemon
	 **/
	slotStartDaemon();
}

/**
 ** CxWndMain::setStatusMsg(): Set the statusbar message.
 **/
void		CxWndMain::setStatusMsg(const QString& s) {

	statusBar()->changeItem(s,2);
}

/**
 ** CxWndMain::isConnected(): Are we online?
 **/
int		CxWndMain::isConnected() {

	return(Connected);
}

/**
 ** CxWndMain::setConnected(): Set whether or not we are online.
 **/
void		CxWndMain::setConnected(int i) {

	Connected = i;

	if(i) {
		statusBar()->clear();
		statusBar()->changeItem(QString("Online"),1);
	} else {
		statusBar()->clear();
		statusBar()->changeItem(QString("Offline"),1);
	}
}

/**
 ** CxWndMain::closeEvent(): What do we do when we exit?
 **/
void 		CxWndMain::closeEvent(QCloseEvent *) {

	KConfig *config = KGlobal::config();
	saveProperties(config);
	saveMainWindowSettings(config);
	config->sync();

	_RoomIndex = CxLlFlush(_RoomIndex);
	_FloorIndex = CxLlFlush(_FloorIndex);

	if(isConnected()) {
		CxClSend(g_cxHndl, "QUIT");
		CxClDisconnect( g_cxHndl );
		CxClDelete( g_cxHndl );
	}
	kapp->quit();
}

/**
 ** CxWndMain::slotChat(): Launch a new chat window.
 **/
void		CxWndMain::slotChat() {
	
        if (!kapp->dcopClient()->send("InfusionDaemon","CxDaemonMgr","buddyList()","")) {
		cerr << "Infusion::slotChat(): DCOP communications may be broken!" << endl;
		KMessageBox::sorry( this,
			QString("I was unable to contact the Infusion Daemon!\nPerhaps it has crashed?"),
			QString("Failed!"),
			false
		);
        }
}

/**
 ** CxWndMain::recvExpMesg(): Check for express message.
void		CxWndMain::recvExpMesg() {

	char *s = CxMiExpRecv( g_cxHndl );

	if(!s) return;

	_serialize(s);

	CxWndChat *win = &chatWin(QString(g_Ser[3]));
	if(win) {
		win->recvMesg(g_Ser[5]);
		win->show();
	}

	free(s);
}
 **/

/**
 ** CxWndMain::checkExpMesg(): Check for express message.
void		CxWndMain::checkExpMesg() {

	QTimer::singleShot( 6000, this, SLOT(checkExpMesg()) );

	if(User.isEmpty()) return;

	if(CxMiExpCheck( g_cxHndl )) {
		emit recvExpMesg();
	}
}
 **/

/**
 ** CxWndMain::slotNewMessage(): Launch a new Message Composer.
 **/
void		CxWndMain::slotNewMessage() {

	if((QString(Room) == "Mail") || (CxMsSaveOk(g_cxHndl, User.ascii()))) {
		CxWndMesg *msg = new CxWndMesg(QString::null, QString::null, QString(Room), QString::null, true);
		msg->show();
	} else {
		KMessageBox::sorry(this,
			QString("You do not have permission to post messages in this room!"),
			QString("Permission Denied!"),
			false
		);
	}
}

/**
 ** CxWndMain::slotNewNote(): Launch a new Note window.
 **/
void		CxWndMain::slotNewNote() {
	CxWndNote *note = new CxWndNote(NULL, QString::null);
	note->show();
}

/**
 ** CxWndMain::slotNewTask(): Launch a new Task Composer.
 **/
void		CxWndMain::slotNewTask() {

	CxWndTask *msg = new CxWndTask(1);
	msg->show();
}

/**
 ** CxWndMain::slotDisconnect(): Time to log off...
 **/
void		CxWndMain::slotDisconnect() {
int		i = 0;

	if(isConnected()) {
	
		i = KMessageBox::questionYesNo(this, 
				QString("Are you sure you wish to disconnect from ")+
				QString("localhost")+
				QString("?"),
				QString("Disconnect from Server?"),
				QString("Yes"),
				QString("No"),
				false
			);
	}

	/**
	 ** We got 'Yes' back.
	 **/
	if((i==3) || (!isConnected())) {

		emit i_titleBar->slotUpdate(QString("Infusion"), DesktopIcon(QString("mail_generic"),32));
		emit i_folderPane->clear();

		if(!isConnected()) {
			if(_RoomIndex) _RoomIndex = CxLlFlush(_RoomIndex);
			if(_FloorIndex) _FloorIndex = CxLlFlush(_FloorIndex);
			emit i_folderList->clear();

			CxClSend(g_cxHndl, "QUIT");
			CxClDisconnect( g_cxHndl );
			CxClDelete( g_cxHndl );
			setConnected(0);
		}

		CxWndLogin *wndLogin = new CxWndLogin(g_K2App, QString("Hello"));
		wndLogin->show();
	}
}

/**
 ** CxWndMain::slotNext(): Goto next room w/ unread messages.
 **/
void		CxWndMain::slotNext() {
ROOMINFO	*ri;

	if((ri = CxRmGoto(g_cxHndl, NULL,0))) {
		strcpy(Room, ri->name);
		free(ri);
		emit i_folderPane->refresh();
	}
}

/**
 ** CxWndMain::slotExit(): I'm outta here!
 **/
void		CxWndMain::slotExit() {

	close();
}

/**
 ** CxWndMain::processTbEvent(): Process a toolbar event
 **/
void		CxWndMain::processTbEvent(int id) {

	switch(id) {
		case(ID_NEW):
			emit slotNewMessage();
			break;

		case(ID_NEXT):
			emit slotNext();
			break;

		case(ID_REFRESH):
			emit slotRefreshVisiblePane();
			break;

		case(ID_BUDDYLIST):
			emit slotChat();
			break;

		default:
			break;
	}
}

/**
 ** CxWndMain::updateRooms(): Update the i_folderList object.
 **/
void		CxWndMain::updateRooms() {
char		buf[255], buf2[255];
CXLIST		x,y;
QListViewItem	*i, *ii, *iii;
char		fid[10];

	buf[0] = buf2[0] = 0;

	setStatusMsg(QString("Updating room list..."));

	i = new QListViewItem(i_folderList, QString("Personal Folders"));
	i->setPixmap(0, SmallIcon(QString("mail_generic")));
	i->setOpen(true);

	ii = new QListViewItem(i, QString("Calendar"));
	ii->setPixmap(0, SmallIcon(QString("karm")));

	ii = new QListViewItem(i, QString("Contacts"));
	ii->setPixmap(0, SmallIcon(QString("ktalkd")));

	ii = new QListViewItem(i, QString("Deleted Items"));
	ii->setPixmap(0, SmallIcon(QString("trashcan_empty")));

	ii = new QListViewItem(i, QString("Inbox"));
	ii->setPixmap(0, SmallIcon(QString("kword")));

	ii = new QListViewItem(i, QString("Journal"));
	ii->setPixmap(0, SmallIcon(QString("korganizer")));

	ii = new QListViewItem(i, QString("Notes"));
	ii->setPixmap(0, SmallIcon(QString("knotes")));

	ii = new QListViewItem(i, QString("Outbox"));
	ii->setPixmap(0, SmallIcon(QString("folder_open")));

	ii = new QListViewItem(i, QString("Sent Items"));
	ii->setPixmap(0, SmallIcon(QString("folder")));

	ii = new QListViewItem(i, QString("Tasks"));
	ii->setPixmap(0, SmallIcon(QString("klipper")));

	emit wndAction->updateStatus(34, "Retrieving floor index...");
	if(!_FloorIndex) {
		_FloorIndex = CxFlList( g_cxHndl );
	}

	emit wndAction->updateStatus(15, "Retrieving room index...");
	if(!_RoomIndex) {
		_RoomIndex = CxRmList( g_cxHndl );
	}

	i = new QListViewItem(i_folderList, QString("Mailbox - ")+User);
	i->setPixmap(0, SmallIcon(QString("mail_generic")));

	emit wndAction->updateStatus(20, "Preparing room list...");
	ii = new QListViewItem(i, QString("Mail Inbox"));
	ii->setPixmap(0, SmallIcon(QString("kwrite")));

	x = _FloorIndex;
	emit wndAction->updateStatus(67, "Loading room list...");
	while(x) {
		strcpy(buf,x->data);

		_serialize(buf);
		strcpy(fid, g_Ser[0]);

		ii = new QListViewItem(i, QString(g_Ser[1]));
		ii->setPixmap(0, SmallIcon(QString("folder_open")));
		if(!strcmp(fid,"0")) ii->setOpen(true);

		y = _RoomIndex;
		while(y) {
			strcpy(buf2, y->data);
			_serialize(buf2);
			if(!strcmp(fid, g_Ser[2])) {
                                if(strcmp(g_Ser[0], "Mail")) {
					iii = new QListViewItem(ii, QString(g_Ser[0]));
					iii->setPixmap(0,SmallIcon(QString("folder")));
				}
			}
			y = y->next;
		}

		x = x->next;
	}

	setStatusMsg(QString("Idle"));
}

/**
 ** CxWndMain::itemSelected(): What happens when we select an item?
 **/
void		CxWndMain::itemSelected(QListViewItem *item) {

	if(!item) return;

	if(!item->childCount()) {
		emit	gotoRoom(item->text(0));
	}
	return;
}

/**
 ** CxWndMain::gotoRoom(): What happens when we select an item?
 **/
void		CxWndMain::gotoRoom(QString text) {
ROOMINFO	*ri;
char		ss[200];


	strcpy(ss, text.ascii());
	if(!strcmp(ss,"Mail Inbox")) {
		strcpy(ss, "_MAIL_");
	} else if(!strcmp(ss,"Mail")) {
		strcpy(ss, "_MAIL_");
	}

	if((ri = CxRmGoto(g_cxHndl,ss,0))) {
		strcpy(Room, ri->name);

		currentView = CxWndMain::OtherView;
		emit i_titleBar->slotUpdate(QString(ri->name), QPixmap( folder_32x32_xpm ));
		emit i_folderPane->refresh();

		free(ri);
	}
	return;
}

/**
 ** CxWndMain::slotUpdateLstFolders(): Keep the folder list in sync with anything else that's
 ** going on.
 **/
void		CxWndMain::slotUpdateLstFloors(const QString &rm) {
QListViewItem	*i, *ii;

	if(!isConnected()) return;

	i=i_folderList->firstChild();
	while( i->nextSibling() ) {
		i->setSelected(false);
		i = i->nextSibling();
	}

	ii = i->firstChild();
	if( ii ) {
		while( ii ) {
			if(ii->text(0) == rm) ii->setSelected(true);
			else ii->setSelected(false);
			ii = ii->nextSibling();
		}
	}
}

/**
 ** CxWndMain::slotUpdateToolbar(): Adjust the toolbar to represent
 ** our current View.
 **/
void		CxWndMain::slotUpdateToolbar() {

	/**
	 ** The rest of the buttons will change, depending on
	 ** the current view.
	 **/
	switch(currentView) {
		case(InboxView):
		case(OtherView): 
			break;

		case(CalendarView):
			i_calendarPane->CxToolbar()->show();
			break;
		case(ContactsView):
			break;
		case(TasksView):
			break;
		case(JournalView):
			break;
		case(NotesView):
			break;
		case(TrashView):
			break;
	}

	toolBar(0)->show();
}

/**
 ** CxWndMain::slotKoInbox(): Jump to inbox.
 **/
void		CxWndMain::slotKoInbox() {

	if(QString(Room) == "Mail") {
		gotoRoom("Mail");
		emit i_folderPane->refresh();
	}

	currentView = CxWndMain::InboxView;
	emit i_titleBar->slotUpdate(QString("Inbox"), DesktopIcon(QString("kword"),32));
	emit slotUpdateLstFloors(QString("Inbox"));
	toolBar(0)->getButton(tb_NewButtonId)->setDefaultIcon(QString("kword"));
	emit slotUpdateToolbar();
	i_widgetStack->raiseWidget( i_folderPane );
}

/**
 ** CxWndMain::slotKoCalendar(): Jump to contacts view.
 **/
void		CxWndMain::slotKoCalendar() {

	currentView = CxWndMain::CalendarView;

/*	if(i_notesPane->isVisible()) i_notesPane->hide(); 
	if(i_tasksPane->isVisible()) i_tasksPane->hide(); 
	if(i_addressPane->isVisible()) i_addressPane->hide(); 
	if(i_folderPane->isVisible()) i_folderPane->hide();
	if(!i_calendarPane->isVisible()) i_calendarPane->show(); */
	i_widgetStack->raiseWidget( i_calendarPane );

	emit i_titleBar->slotUpdate(i_calendarPane->CxObjectName(), i_calendarPane->CxDesktopIcon());
	emit slotUpdateLstFloors(QString("Calendar"));
	emit slotUpdateToolbar();

}

/**
 ** CxWndMain::slotKoContacts(): Jump to contacts view.
 **/
void		CxWndMain::slotKoContacts() {

/*	if(i_folderPane->isVisible()) i_folderPane->hide();
	if(i_notesPane->isVisible()) i_notesPane->hide();
	if(i_tasksPane->isVisible()) i_tasksPane->hide();
	if(i_calendarPane->isVisible()) i_calendarPane->hide();
	if(!i_addressPane->isVisible()) i_addressPane->show(); */
	i_widgetStack->raiseWidget( i_addressPane );

	currentView = CxWndMain::ContactsView;
	emit i_titleBar->slotUpdate(QString("Contacts"), DesktopIcon(QString("ktalkd"),32));
	emit slotUpdateLstFloors(QString("Contacts"));

	toolBar(0)->getButton(tb_NewButtonId)->setDefaultIcon(QString("ktalkd"));
	emit slotUpdateToolbar();
}

/**
 ** CxWndMain::slotKoNotes(): Jump to notes view.
 **/
void		CxWndMain::slotKoNotes() {

	currentView = CxWndMain::NotesView;
	if(isConnected()) {
		emit slotUpdateLstFloors(QString("Notes"));
	}

	emit i_titleBar->slotUpdate(QString("Notes"), DesktopIcon(QString("knotes"),32));
	toolBar(0)->getButton(tb_NewButtonId)->setDefaultIcon(QString("knotes"));
	emit slotUpdateToolbar();

/*	if(i_folderPane->isVisible()) i_folderPane->hide();
	if(i_addressPane->isVisible()) i_addressPane->hide();
	if(i_tasksPane->isVisible()) i_tasksPane->hide();
	if(i_calendarPane->isVisible()) i_calendarPane->hide();
	if(!i_notesPane->isVisible()) i_notesPane->show(); */
	i_widgetStack->raiseWidget( i_notesPane );
}

/**
 ** CxWndMain::slotKoTasks(): Jump to tasks view.
 **/
void		CxWndMain::slotKoTasks() {

	currentView = CxWndMain::TasksView;
	emit i_titleBar->slotUpdate(QString("Tasks"), DesktopIcon(QString("klipper"),32));
	emit slotUpdateLstFloors(QString("Tasks"));

	toolBar(0)->getButton(tb_NewButtonId)->setDefaultIcon(QString("klipper"));
	emit slotUpdateToolbar();

/*	if(i_folderPane->isVisible()) i_folderPane->hide();
	if(i_addressPane->isVisible()) i_addressPane->hide();
	if(i_calendarPane->isVisible()) i_calendarPane->hide();
	if(i_notesPane->isVisible()) i_notesPane->hide();
	if(!i_tasksPane->isVisible()) i_tasksPane->show(); */
	i_widgetStack->raiseWidget( i_tasksPane );
}

/**
 ** CxWndMain::slotKoJournal(): Jump to journal view.
 **/
void		CxWndMain::slotKoJournal() {

	currentView = CxWndMain::JournalView;
	emit slotUpdateLstFloors(QString("Journal"));
	emit slotUpdateToolbar();
}

/**
 ** CxWndMain::slotKoDeleted(): Jump to deleted items view.
 **/
void		CxWndMain::slotKoDeleted() {

	currentView = CxWndMain::TrashView;
	emit slotUpdateLstFloors(QString("Deleted Items"));
	emit slotUpdateToolbar();
}

/**
 ** CxWndMain::slotToggleKoolBar(): koolbar callback.
 **/
void		CxWndMain::slotToggleKoolBar() {

#ifdef		HAVE_KOOLBAR
	if(i_koolBar->isVisible()) i_koolBar->hide();
	else i_koolBar->show();
#endif
}

/**
 ** CxWndMain::slotKoolBar(): koolbar callback.
 **/
void		CxWndMain::slotKoolBar(int group, int item) {

	switch(group) {
		case(0):
		switch(item) {
			case(1):			// INBOX
				emit slotKoInbox();
				break;
			case(2):			// CALENDAR
				emit slotKoCalendar();
				break;
			case(3):			// CONTACTS
				emit slotKoContacts();
				break;
			case(4):			// TASKS	
				emit slotKoTasks();
				break;
			case(6):			// NOTES
				emit slotKoNotes();
				break;
		} break;
	}
}

/**
 ** CxWndMain::slotToggleRooms(): Toggle rooms list.
 **/
void		CxWndMain::slotToggleRooms() {

	if(i_folderList->isVisible()) i_folderList->hide();
	else i_folderList->show();
	view->setItemChecked(m_id_view_folderlist, !view->isItemChecked(m_id_view_folderlist));
}

/**
 ** CxWndMain::slotToggleStatusBar(): Toggle status bar.
 **/
void		CxWndMain::slotToggleStatusBar() {

	if(statusBar()->isVisible()) statusBar()->hide();
	else statusBar()->show();
	view->setItemChecked(m_id_view_statusbar, !view->isItemChecked(m_id_view_statusbar));
}

/**
 ** CxWndMain::initializeClient(): Startup stuff.
 **/
void		CxWndMain::initializeClient() {

	emit updateRooms();
	emit i_folderList->refreshList();
	emit i_folderPane->refresh();
	emit i_tasksPane->refreshList();
	emit i_notesPane->refreshList();
	emit i_calendarPane->refresh();
	emit wndAction->updateStatus(100, "Welcome to Infusion!");

	QTimer *mytimer = new QTimer(this, "wndMain.tickTock.bewmAction");
	mytimer->singleShot(1000, wndAction, SLOT(close()));
}

/**
 ** CxWndMain::slotAbout(): About Us.
 **/
void		CxWndMain::slotAbout() {

	CxWndAbout *about = new CxWndAbout(NULL, QString("About Infusion"));
	about->show();
}

/**
 ** CxWndMain::saveProperties(): ...
 **/
void		CxWndMain::saveProperties(KConfig *config) {
QString		view("View");

	/**
	 ** Inbox
	 **/
	if(currentView==InboxView) {
		config->writeEntry(view, QString("InboxView"), true, true, false);

	} else if(currentView==CalendarView) {
		config->writeEntry(view, QString("CalendarView"), true, true, false);

	} else if(currentView==ContactsView) {
		config->writeEntry(view, QString("ContactsView"), true, true, false);

	} else if(currentView==TasksView) {
		config->writeEntry(view, QString("TasksView"), true, true, false);

	} else if(currentView==NotesView) {
		config->writeEntry(view, QString("NotesView"), true, true, false);

	} else if(currentView==JournalView) {
		config->writeEntry(view, QString("JournalView"), true, true, false);

	} else {
		config->writeEntry(view, QString("OtherView:")+QString(Room), true, true, false);
	}

	view = QString("FolderListVisible");
	if(i_folderList->isVisible()) config->writeEntry(view, QString("On"), true, true, false);
	else config->writeEntry(view, QString("Off"), true, true, false);

	view = QString("StatusBarVisible");
	if(statusBar()->isVisible()) config->writeEntry(view, QString("On"), true, true, false);
	else config->writeEntry(view, QString("Off"), true, true, false);

	/*view = QString("MessagePaneVisible");
	if(i_mesgPane->isVisible()) config->writeEntry(view, QString("On"), true, true, false);
	else config->writeEntry(view, QString("Off"), true, true, false);*/

#ifdef		HAVE_KOOLBAR
	view = QString("InfusionBarVisible");
	if(i_kbContainer->isVisible()) config->writeEntry(view, QString("On"), true, true, false);
	else config->writeEntry(view, QString("Off"), true, true, false);
#endif
}

/**
 ** CxWndMain::readProperties(): ...
 **/
void		CxWndMain::readProperties(KConfig *config) {
QString		key("View");
QString		value;

	value = config->readEntry( key, "InboxView");

	/**
	 ** Inbox view active.
	 **/
	if(value == "InboxView") {
		emit slotKoInbox();

	/**
	 ** Calendar view active.
	 **/
	} else if(value == "CalendarView") {
		emit slotKoCalendar();

	/**
	 ** Contacts view active.
	 **/
	} else if(value == "ContactsView") {
		emit slotKoContacts();

	/**
	 ** Tasks view active.
	 **/
	} else if(value == "TasksView") {
		emit slotKoTasks();

	/**
	 ** Journal view active.
	 **/
	} else if(value == "JournalView") {
		emit slotKoJournal();

	/**
	 ** Notes view active.
	 **/
	} else if(value == "NotesView") {
		emit slotKoNotes();

	/**
	 ** User had his mind in the dirt when he exited.
	 **/
	} else if(value == "TrashView") {
		emit slotKoDeleted();

	/**
	 ** User was in a folder when they exited.
	 **/
	} else {
		emit slotKoInbox();
	}

	/**
	 ** Was the FolderList visible?
	 **/
	key = QString("FolderListVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		view->setItemChecked(m_id_view_folderlist, false);
		i_folderList->hide();
	} else {
		view->setItemChecked(m_id_view_folderlist, true);
	}

	key = QString("StatusBarVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		view->setItemChecked(m_id_view_statusbar, false);
		statusBar()->hide();
	} else {
		view->setItemChecked(m_id_view_statusbar, true);
	}

	/*key = QString("MessagePaneVisible");
	value = config->readEntry(key, "On");
	if(value != "On") {
		view->setItemChecked(m_id_view_mesgpane, false);
		i_mesgPane->hide();
	} else {
		view->setItemChecked(m_id_view_mesgpane, true);
	}*/

#ifdef		HAVE_KOOLBAR
	key = QString("InfusionBarVisible");
	value = config->readEntry(key, "On");
	if(value != "On")
		i_kbContainer->hide();
#endif
}

/**
 ** CxWndMain::slotRefreshVisiblePane(): Determine which item is
 ** currently visible, and refresh ONLY that item.  This will make
 ** view switching much faster.
 **/
void		CxWndMain::slotRefreshVisiblePane() {

	kapp->setOverrideCursor(waitCursor);
	switch(currentView) {
		case(InboxView):
		case(OtherView):
			emit i_folderPane->refresh();
			break;
		case(CalendarView):
			emit i_calendarPane->refresh();
			break;
		case(ContactsView):
			break;
		case(TasksView):
			emit i_tasksPane->refreshList();
			break;
		case(JournalView):
			break;
		case(NotesView):
			emit i_notesPane->refreshList();
			break;
	}
	kapp->restoreOverrideCursor();
}

/**
 ** CxWndMain::slotStartDaemon(): Start the Infusion Daemon.
 **/
void		CxWndMain::slotStartDaemon() {

        /**
         ** If the Infusion Daemon is not running, we need to start it here.  It is
         ** a KUniqueApplication, so we shouldn't need to worry about whether or not
         ** it's running.
         **/
        QString execStr = locate("exe","infusiond");
        system(execStr.latin1());
 
        // Force alarm daemon to load active calendar
        if (!kapp->dcopClient()->send("InfusionDaemon","CxDaemonMgr","sync()","")) {
		cerr << "Infusion::slotStartDaemon(): DCOP communications may be broken!" << endl;
        }
}

/**
 ** This software will support sound events sometime in the near future...
 **
	KNotifyClient::event("Offline");
 **/
