/**
 ** infusion - The Desktop Communications Revolution
 ** Copyright (c) 2000, SCCG/Flaming Sword Productions
 ** All Rights Reserved
 **
 ** Module: modules/ui/kde2/wndmesg.o
 ** Date: 2000-10-15
 ** Last Revision: 2000-10-15
 ** Description: Message composer.
 ** CVS: $Id: wndmesg.cpp,v 1.4 2001/05/16 22:40:45 brian Exp $
 **/
extern "C" {
#include	<stdlib.h>
#include	<unistd.h>
};
#include        <iostream.h>
#include        <qapplication.h>
#include        <qpushbutton.h>
#include        <qlayout.h>
#include        <qframe.h>
#include        <kglobal.h>
#include        <kiconloader.h>
#include        <ktoolbar.h>
#include        <kaccel.h>
#include        <klineedit.h>
#include        <kdialog.h>
#include        <klocale.h>
#include        <ktabctl.h>
#include        <kmessagebox.h>
#include        <qstring.h>
#include        <CxClient.h>
#include	"wndmain.h"
#include	"wndaddress.h"
#include	"wndmesg.h"
#include	"autoconf.h"

#define		ID_SEND		0x1

extern CxWndMain *wndMain;

/**
 ** CxWndMesg::CxWndMesg(): Constructor
 **/
		CxWndMesg::CxWndMesg(const QString& to, const QString& subj, const QString& room, const QString& body, bool is_composer_win) : 
			KMainWindow(0, 0) {
int	i;

	i_am_a_composer = is_composer_win;

	setCaption(subj?subj:QString("No Subject"));

        KAccel *keys = new KAccel(this);
        keys->connectItem(KStdAccel::Close, this, SLOT(slotClose()));
        keys->insertItem(i18n("SendMessage"), "SendMessage", CTRL+Key_Return);
        keys->insertItem(i18n("RunQuickly"), "RunQuickly", Key_Escape);
        keys->connectItem("SendMessage", this, SLOT(onSend()));
        keys->connectItem("RunQuickly", this, SLOT(slotClose()));
	keys->readSettings();

	file = new QPopupMenu();
	go = new QPopupMenu();
	compose = new QPopupMenu();
	help = helpMenu(QString("infusion Release ")+QString(VERSION)+QString("\nCopyright (c) 2000, Flaming Sword Productions\nThis product is free for use and distribution"));

	compose->insertItem(SmallIcon(QString("filenew")), QString("&New Mail Message"), NULL);
	compose->insertItem( QString("New Po&st in This Folder"), NULL);
	compose->insertItem( QString("C&hoose Template..."), NULL);
	compose->insertItem( QString("Ch&oose Form..."), NULL);
	compose->insertSeparator();
	compose->insertItem(SmallIcon(QString("mail_reply")), QString("&Reply"), NULL);
	compose->insertItem(SmallIcon(QString("mail_replyall")), QString("Reply to A&ll"), NULL);
	compose->insertItem(SmallIcon(QString("mail_forward")), QString("For&ward"), NULL);

        go->insertItem(SmallIcon(QString("kword")), i18n("Inbox"), NULL);
        go->insertItem(SmallIcon(QString("karm")), i18n("Calendar"), NULL);
        go->insertItem(SmallIcon(QString("ktalkd")), i18n("Contacts"), NULL);
        go->insertItem(SmallIcon(QString("klipper")), i18n("Tasks"), NULL);
        go->insertItem(SmallIcon(QString("korganizer")), i18n("Journal"), NULL);
        go->insertItem(SmallIcon(QString("knotes")), i18n("Notes"), NULL);
        go->insertItem(SmallIcon(QString("trashcan_empty")), i18n("Deleted Items"), NULL);

	page = new QVBox(this);
	page->setMargin(KDialog::marginHint());
	page->setSpacing(KDialog::spacingHint());
	setCentralWidget(page);

	// COMPOSER window.
	if(is_composer_win) {

		i = file->insertItem("&Send Message", this, SLOT(onSend()));
		keys->changeMenuAccel(file, i, "SendMessage");
		file->insertSeparator();

		toolBar(0)->insertButton(QString("mail_send"),ID_SEND, true, QString("Send Message"), -1, KGlobal::instance());
		toolBar(0)->insertLineSeparator();
		i = toolBar(0)->insertButton(QString("filesave"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);
		i = toolBar(0)->insertButton(QString("fileprint"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);
		toolBar(0)->insertLineSeparator();
		i = toolBar(0)->insertButton(QString("editcut"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);
		i = toolBar(0)->insertButton(QString("editcopy"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);
		i = toolBar(0)->insertButton(QString("editpaste"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);
		i = toolBar(0)->insertButton(QString("attach"),ID_SEND, true, QString(""), -1, KGlobal::instance());
		toolBar(0)->setItemEnabled(i, false);

		connect(toolBar(0), SIGNAL(clicked(int)), this, SLOT(processTbEvent(int)));
		toolBar(0)->setIconText( KToolBar::IconTextRight );
		toolBar(0)->setFullSize(false);

		KTabCtl *tabs = new KTabCtl(page);
		QWidget *tb1 = new QWidget(tabs);
		tabs->addTab(tb1, QString("Message"));

		QGridLayout *grid = new QGridLayout(tb1,2,2,KDialog::marginHint() ,KDialog::spacingHint(),"wndMesgGrid");

		if(room == "Mail") {
			QPushButton *lblRcpt = new QPushButton(QString("To..."), tb1,"wndMesgLblRcpt");
			grid->addWidget(lblRcpt,1,1,0);
			connect(lblRcpt, SIGNAL(clicked()), this, SLOT(openAddresser()));

			lRcpt = new KLineEdit(to, tb1, "wndMesgRcpt");
			grid->addWidget(lRcpt,1,2,0);

			QPushButton *lblCc = new QPushButton(QString("Cc..."), tb1, "wndMesg.lblCc");
			lblCc->hide();
			//grid->addWidget(lCc,1,3,0);
			connect(lblCc, SIGNAL(clicked()), this, SLOT(openAddresser()));

			lCc = new KLineEdit(to, tb1, "wndMesg.txtCc");
			lCc->hide();
			//grid->addWidget(lRcpt,1,3,0);


		} else {
			lRcpt = NULL;
			QLabel *lblRoom = new QLabel(QString("Room:"), tb1, "wndMesgLblRoom");
			grid->addWidget(lblRoom,1,1,0);

			QLabel *lneRoom = new QLabel(room, tb1, "wndMesgLneRoom");
			grid->addWidget(lneRoom,1,2,0);
		}

		QLabel *lblSubj = new QLabel(QString("Subject:"), tb1, "wndMesgLblSubj");
		grid->addWidget(lblSubj,2,1,0);

		lSubj = new KLineEdit(subj, tb1, "wndMesgSubj");
		connect(lSubj, SIGNAL(textChanged(const QString &)), this, SLOT(slotUpdateCaption(const QString &)));
		grid->addWidget(lSubj,2,2,0);

		if(lRcpt) lRcpt->setFocus();
		else lSubj->setFocus();

	// READER window.
	} else {

		// Outlook-ish File menu
		file->insertItem("Ne&w...", NULL);
		file->insertSeparator();
		file->insertItem("&Save", NULL);
		file->insertItem("Save &As...", NULL);
		file->insertSeparator();
		file->insertItem("&Delete", NULL);
		file->insertItem("&Move to Folder...", NULL);
		file->insertItem("Cop&y to Folder...", NULL);
		file->insertSeparator();
		file->insertItem("&Print", NULL);
		file->insertSeparator();
		file->insertItem("&Properties", NULL);
		file->insertSeparator();

		toolBar(0)->insertButton(QString("mail_reply"),ID_SEND, true, QString("Reply"), -1, KGlobal::instance());
		toolBar(0)->insertLineSeparator();
		toolBar(0)->insertButton(QString("mail_replyall"),ID_SEND, true, QString("Reply to All"), -1, KGlobal::instance());
		toolBar(0)->setIconText( KToolBar::IconTextRight );
//tmp		connect(toolBar(0), SIGNAL(clicked(int)), this, SLOT(processTbEvent(int)));

		QWidget *gw = new QWidget(page);
		QGridLayout *grid = new QGridLayout(gw, 4, 2, KDialog::marginHint() , KDialog::spacingHint(), "wndMesgGrid");

		QLabel *lblSender = new QLabel(gw);
		lblSender->setText(QString("From:"));
		grid->addWidget(lblSender, 0, 0, 0);

		QLabel *txtSender = new QLabel(gw);
		lblSender->setText(QString::null);
		grid->addWidget(txtSender, 0, 1, 0);

		QLabel *lblRcpt = new QLabel(gw);
		lblRcpt->setText(QString("To:"));
		grid->addWidget(lblRcpt, 1, 0, 0);

		QLabel *txtRcpt = new QLabel(gw);
		txtRcpt->setText(to);
		grid->addWidget(txtRcpt, 1, 1, 0);

		QLabel *lblCc = new QLabel(gw);
		lblCc->setText(QString("Cc:"));
		grid->addWidget(lblCc, 2, 0, 0);

		QLabel *txtCc = new QLabel(gw);
		txtCc->setText(QString::null);
		grid->addWidget(txtCc, 2, 1, 0);

		QLabel *lblSubj = new QLabel(gw);
		lblSubj->setText(QString("Subject:"));
		grid->addWidget(lblSubj, 3, 0, 0);

		QLabel *txtSubj = new QLabel(gw);
		txtSubj->setText(subj);
		grid->addWidget(txtSubj, 3, 1, 0);
	}
	file->insertItem("&Close", this, SLOT(slotClose()));  

	menuBar()->insertItem("&File", file);
	menuBar()->insertItem("&Go", go);
	menuBar()->insertItem("Co&mpose", compose);
	menuBar()->insertItem("&Help", help);

	txtBody = new QMultiLineEdit(page, "wndMesgBody");
	txtBody->setWordWrap(QMultiLineEdit::WidgetWidth);
	txtBody->setText(body);
	connect(txtBody, SIGNAL(textChanged()), this, SLOT(slotChanged()));

	ive_been_changed = 0;

	resize(
		QApplication::desktop()->width() * 0.45, 
		QApplication::desktop()->height() * 0.45
	);
	move(
		(QApplication::desktop()->width() - width())/2, 
		(QApplication::desktop()->height() - height())/2
	);
}

/**
 ** CxWndMesg::slotChanged(): What if somebody edits us??
 **/
void		CxWndMesg::slotChanged() {
	ive_been_changed = 1; // ive_been_assaulted = 0;
}

/**
 ** CxWndMesg::onSend(): Send message
 **/
void		CxWndMesg::onSend() {
MESGINFO	msg;

	if(!i_am_a_composer) return;

	if(!*(txtBody->text().ascii())) {
		int i = KMessageBox::questionYesNo(this,
                        QString("Are you sure you wish to send a blank message?"),
                        QString("Send blank message?"),
                        QString("Yes"),
                        QString("No"),
                        false
                );
		if(i!=3) return;
	}

	strcpy(msg.subject, lSubj->text().ascii());
	if(lRcpt) strcpy(msg.rcpt, lRcpt->text().ascii());
	else msg.rcpt[0] = 0;
	strcpy(msg.author, wndMain->getUserName());
	msg.date[0] = 0;
	msg.path[0] = 0;

	msg.body = (char *)malloc(strlen(txtBody->text().ascii())+1);
	strcpy(msg.body, txtBody->text().ascii());

	if(CxMsSave(wndMain->getHndl(), msg)) {
		KMessageBox::sorry(this,
                        QString("I was unable to send your message.  Please check the recipient's name and try again."),
                        QString("Unable to Send"),
                        false
		);
		free(msg.body);
		
	} else {

		free(msg.body);
		close();
	}
}

/**
 ** CxWndMain::closeEvent(): What do we do when we exit?
 **/
void            CxWndMesg::closeEvent(QCloseEvent *) {

	delete(this);
}

/**
 ** CxWndMesg::slotClose(): Exit
 **/
void		CxWndMesg::slotClose() {
int		i;

	if(ive_been_changed) {
		i = KMessageBox::questionYesNo(this,
				(i_am_a_composer?QString("Are you sure you wish to cancel the\nchanges you made to this message?"):QString("Are you sure you wish to abort\nthis message?")),
				QString("Cancel changes?"),
				QString("&Yes"),
				QString("&No"),
				false
		);

		if(i != 3) {
			return;
		}

	}

	close();
}

/**
 ** CxWndMesg::processTbEvent(): What happens when button x is hit?
 **/
void		CxWndMesg::processTbEvent(int x) {
	switch(x) {

		case(ID_SEND):
			emit onSend();
			break;

		default:
			break;
	}
}

/**
 ** CxWndMesg::slotUpdateCaption(): Update the titlebar.
 **/
void		CxWndMesg::slotUpdateCaption(const QString &txt) {

	setCaption( (txt.isEmpty())?QString("No Subject"):txt );
}

/**
 ** CxWndMesg::openAddresser(): Open an addresser window.
 **/
void		CxWndMesg::openAddresser() {

	CxWndAddress *adwin = new CxWndAddress(this, QString::null);
	connect(adwin, SIGNAL(setRcptAddr(const QString &)), this, 
			SLOT(setRcptAddr(const QString &)));
	adwin->show();
}

/**
 ** CxWndMesg::setRcptAddr(): Set the recipient's address (called by CxWndAddress)
 **/
void		CxWndMesg::setRcptAddr(const QString & s) {
	if(lRcpt) lRcpt->setText(s);
}
